// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class BoletoDataTypeStruct extends BaseStruct {
  BoletoDataTypeStruct({
    String? idBoleto,
    String? cdLinhaDigitavel,
    int? idContrato,
  })  : _idBoleto = idBoleto,
        _cdLinhaDigitavel = cdLinhaDigitavel,
        _idContrato = idContrato;

  // "idBoleto" field.
  String? _idBoleto;
  String get idBoleto => _idBoleto ?? '';
  set idBoleto(String? val) => _idBoleto = val;

  bool hasIdBoleto() => _idBoleto != null;

  // "cdLinhaDigitavel" field.
  String? _cdLinhaDigitavel;
  String get cdLinhaDigitavel => _cdLinhaDigitavel ?? '';
  set cdLinhaDigitavel(String? val) => _cdLinhaDigitavel = val;

  bool hasCdLinhaDigitavel() => _cdLinhaDigitavel != null;

  // "idContrato" field.
  int? _idContrato;
  int get idContrato => _idContrato ?? 0;
  set idContrato(int? val) => _idContrato = val;

  void incrementIdContrato(int amount) => idContrato = idContrato + amount;

  bool hasIdContrato() => _idContrato != null;

  static BoletoDataTypeStruct fromMap(Map<String, dynamic> data) =>
      BoletoDataTypeStruct(
        idBoleto: data['idBoleto'] as String?,
        cdLinhaDigitavel: data['cdLinhaDigitavel'] as String?,
        idContrato: castToType<int>(data['idContrato']),
      );

  static BoletoDataTypeStruct? maybeFromMap(dynamic data) => data is Map
      ? BoletoDataTypeStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'idBoleto': _idBoleto,
        'cdLinhaDigitavel': _cdLinhaDigitavel,
        'idContrato': _idContrato,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'idBoleto': serializeParam(
          _idBoleto,
          ParamType.String,
        ),
        'cdLinhaDigitavel': serializeParam(
          _cdLinhaDigitavel,
          ParamType.String,
        ),
        'idContrato': serializeParam(
          _idContrato,
          ParamType.int,
        ),
      }.withoutNulls;

  static BoletoDataTypeStruct fromSerializableMap(Map<String, dynamic> data) =>
      BoletoDataTypeStruct(
        idBoleto: deserializeParam(
          data['idBoleto'],
          ParamType.String,
          false,
        ),
        cdLinhaDigitavel: deserializeParam(
          data['cdLinhaDigitavel'],
          ParamType.String,
          false,
        ),
        idContrato: deserializeParam(
          data['idContrato'],
          ParamType.int,
          false,
        ),
      );

  @override
  String toString() => 'BoletoDataTypeStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is BoletoDataTypeStruct &&
        idBoleto == other.idBoleto &&
        cdLinhaDigitavel == other.cdLinhaDigitavel &&
        idContrato == other.idContrato;
  }

  @override
  int get hashCode =>
      const ListEquality().hash([idBoleto, cdLinhaDigitavel, idContrato]);
}

BoletoDataTypeStruct createBoletoDataTypeStruct({
  String? idBoleto,
  String? cdLinhaDigitavel,
  int? idContrato,
}) =>
    BoletoDataTypeStruct(
      idBoleto: idBoleto,
      cdLinhaDigitavel: cdLinhaDigitavel,
      idContrato: idContrato,
    );
