// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class BoletoStruct extends BaseStruct {
  BoletoStruct({
    int? id,
    String? vencimento,
    double? valor,
    bool? pago,
  })  : _id = id,
        _vencimento = vencimento,
        _valor = valor,
        _pago = pago;

  // "id" field.
  int? _id;
  int get id => _id ?? 0;
  set id(int? val) => _id = val;

  void incrementId(int amount) => id = id + amount;

  bool hasId() => _id != null;

  // "vencimento" field.
  String? _vencimento;
  String get vencimento => _vencimento ?? '';
  set vencimento(String? val) => _vencimento = val;

  bool hasVencimento() => _vencimento != null;

  // "valor" field.
  double? _valor;
  double get valor => _valor ?? 0.0;
  set valor(double? val) => _valor = val;

  void incrementValor(double amount) => valor = valor + amount;

  bool hasValor() => _valor != null;

  // "pago" field.
  bool? _pago;
  bool get pago => _pago ?? false;
  set pago(bool? val) => _pago = val;

  bool hasPago() => _pago != null;

  static BoletoStruct fromMap(Map<String, dynamic> data) => BoletoStruct(
        id: castToType<int>(data['id']),
        vencimento: data['vencimento'] as String?,
        valor: castToType<double>(data['valor']),
        pago: data['pago'] as bool?,
      );

  static BoletoStruct? maybeFromMap(dynamic data) =>
      data is Map ? BoletoStruct.fromMap(data.cast<String, dynamic>()) : null;

  Map<String, dynamic> toMap() => {
        'id': _id,
        'vencimento': _vencimento,
        'valor': _valor,
        'pago': _pago,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'id': serializeParam(
          _id,
          ParamType.int,
        ),
        'vencimento': serializeParam(
          _vencimento,
          ParamType.String,
        ),
        'valor': serializeParam(
          _valor,
          ParamType.double,
        ),
        'pago': serializeParam(
          _pago,
          ParamType.bool,
        ),
      }.withoutNulls;

  static BoletoStruct fromSerializableMap(Map<String, dynamic> data) =>
      BoletoStruct(
        id: deserializeParam(
          data['id'],
          ParamType.int,
          false,
        ),
        vencimento: deserializeParam(
          data['vencimento'],
          ParamType.String,
          false,
        ),
        valor: deserializeParam(
          data['valor'],
          ParamType.double,
          false,
        ),
        pago: deserializeParam(
          data['pago'],
          ParamType.bool,
          false,
        ),
      );

  @override
  String toString() => 'BoletoStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is BoletoStruct &&
        id == other.id &&
        vencimento == other.vencimento &&
        valor == other.valor &&
        pago == other.pago;
  }

  @override
  int get hashCode => const ListEquality().hash([id, vencimento, valor, pago]);
}

BoletoStruct createBoletoStruct({
  int? id,
  String? vencimento,
  double? valor,
  bool? pago,
}) =>
    BoletoStruct(
      id: id,
      vencimento: vencimento,
      valor: valor,
      pago: pago,
    );
