// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class CreatedUserStruct extends BaseStruct {
  CreatedUserStruct({
    String? nomeCompleto,
    String? cpf,
    String? whatsapp,
    String? email,
    int? id,
    String? status,
    String? dataCriacao,
  })  : _nomeCompleto = nomeCompleto,
        _cpf = cpf,
        _whatsapp = whatsapp,
        _email = email,
        _id = id,
        _status = status,
        _dataCriacao = dataCriacao;

  // "nome_completo" field.
  String? _nomeCompleto;
  String get nomeCompleto => _nomeCompleto ?? '';
  set nomeCompleto(String? val) => _nomeCompleto = val;

  bool hasNomeCompleto() => _nomeCompleto != null;

  // "cpf" field.
  String? _cpf;
  String get cpf => _cpf ?? '';
  set cpf(String? val) => _cpf = val;

  bool hasCpf() => _cpf != null;

  // "whatsapp" field.
  String? _whatsapp;
  String get whatsapp => _whatsapp ?? '';
  set whatsapp(String? val) => _whatsapp = val;

  bool hasWhatsapp() => _whatsapp != null;

  // "email" field.
  String? _email;
  String get email => _email ?? '';
  set email(String? val) => _email = val;

  bool hasEmail() => _email != null;

  // "id" field.
  int? _id;
  int get id => _id ?? 0;
  set id(int? val) => _id = val;

  void incrementId(int amount) => id = id + amount;

  bool hasId() => _id != null;

  // "status" field.
  String? _status;
  String get status => _status ?? '';
  set status(String? val) => _status = val;

  bool hasStatus() => _status != null;

  // "data_criacao" field.
  String? _dataCriacao;
  String get dataCriacao => _dataCriacao ?? '';
  set dataCriacao(String? val) => _dataCriacao = val;

  bool hasDataCriacao() => _dataCriacao != null;

  static CreatedUserStruct fromMap(Map<String, dynamic> data) =>
      CreatedUserStruct(
        nomeCompleto: data['nome_completo'] as String?,
        cpf: data['cpf'] as String?,
        whatsapp: data['whatsapp'] as String?,
        email: data['email'] as String?,
        id: castToType<int>(data['id']),
        status: data['status'] as String?,
        dataCriacao: data['data_criacao'] as String?,
      );

  static CreatedUserStruct? maybeFromMap(dynamic data) => data is Map
      ? CreatedUserStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'nome_completo': _nomeCompleto,
        'cpf': _cpf,
        'whatsapp': _whatsapp,
        'email': _email,
        'id': _id,
        'status': _status,
        'data_criacao': _dataCriacao,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'nome_completo': serializeParam(
          _nomeCompleto,
          ParamType.String,
        ),
        'cpf': serializeParam(
          _cpf,
          ParamType.String,
        ),
        'whatsapp': serializeParam(
          _whatsapp,
          ParamType.String,
        ),
        'email': serializeParam(
          _email,
          ParamType.String,
        ),
        'id': serializeParam(
          _id,
          ParamType.int,
        ),
        'status': serializeParam(
          _status,
          ParamType.String,
        ),
        'data_criacao': serializeParam(
          _dataCriacao,
          ParamType.String,
        ),
      }.withoutNulls;

  static CreatedUserStruct fromSerializableMap(Map<String, dynamic> data) =>
      CreatedUserStruct(
        nomeCompleto: deserializeParam(
          data['nome_completo'],
          ParamType.String,
          false,
        ),
        cpf: deserializeParam(
          data['cpf'],
          ParamType.String,
          false,
        ),
        whatsapp: deserializeParam(
          data['whatsapp'],
          ParamType.String,
          false,
        ),
        email: deserializeParam(
          data['email'],
          ParamType.String,
          false,
        ),
        id: deserializeParam(
          data['id'],
          ParamType.int,
          false,
        ),
        status: deserializeParam(
          data['status'],
          ParamType.String,
          false,
        ),
        dataCriacao: deserializeParam(
          data['data_criacao'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'CreatedUserStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is CreatedUserStruct &&
        nomeCompleto == other.nomeCompleto &&
        cpf == other.cpf &&
        whatsapp == other.whatsapp &&
        email == other.email &&
        id == other.id &&
        status == other.status &&
        dataCriacao == other.dataCriacao;
  }

  @override
  int get hashCode => const ListEquality()
      .hash([nomeCompleto, cpf, whatsapp, email, id, status, dataCriacao]);
}

CreatedUserStruct createCreatedUserStruct({
  String? nomeCompleto,
  String? cpf,
  String? whatsapp,
  String? email,
  int? id,
  String? status,
  String? dataCriacao,
}) =>
    CreatedUserStruct(
      nomeCompleto: nomeCompleto,
      cpf: cpf,
      whatsapp: whatsapp,
      email: email,
      id: id,
      status: status,
      dataCriacao: dataCriacao,
    );
