// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class DependentesDatatypeStruct extends BaseStruct {
  DependentesDatatypeStruct({
    String? dtInclusao,
    String? dtCarencia,
    String? nmGrau,
    String? nmPessoa,
    String? dtNascimento,
    String? nmVinculo,
    String? cdCPF,
    int? idPessoa,
  })  : _dtInclusao = dtInclusao,
        _dtCarencia = dtCarencia,
        _nmGrau = nmGrau,
        _nmPessoa = nmPessoa,
        _dtNascimento = dtNascimento,
        _nmVinculo = nmVinculo,
        _cdCPF = cdCPF,
        _idPessoa = idPessoa;

  // "dtInclusao" field.
  String? _dtInclusao;
  String get dtInclusao => _dtInclusao ?? '';
  set dtInclusao(String? val) => _dtInclusao = val;

  bool hasDtInclusao() => _dtInclusao != null;

  // "dtCarencia" field.
  String? _dtCarencia;
  String get dtCarencia => _dtCarencia ?? '';
  set dtCarencia(String? val) => _dtCarencia = val;

  bool hasDtCarencia() => _dtCarencia != null;

  // "nmGrau" field.
  String? _nmGrau;
  String get nmGrau => _nmGrau ?? '';
  set nmGrau(String? val) => _nmGrau = val;

  bool hasNmGrau() => _nmGrau != null;

  // "nmPessoa" field.
  String? _nmPessoa;
  String get nmPessoa => _nmPessoa ?? '';
  set nmPessoa(String? val) => _nmPessoa = val;

  bool hasNmPessoa() => _nmPessoa != null;

  // "dtNascimento" field.
  String? _dtNascimento;
  String get dtNascimento => _dtNascimento ?? '';
  set dtNascimento(String? val) => _dtNascimento = val;

  bool hasDtNascimento() => _dtNascimento != null;

  // "nmVinculo" field.
  String? _nmVinculo;
  String get nmVinculo => _nmVinculo ?? '';
  set nmVinculo(String? val) => _nmVinculo = val;

  bool hasNmVinculo() => _nmVinculo != null;

  // "cdCPF" field.
  String? _cdCPF;
  String get cdCPF => _cdCPF ?? '';
  set cdCPF(String? val) => _cdCPF = val;

  bool hasCdCPF() => _cdCPF != null;

  // "idPessoa" field.
  int? _idPessoa;
  int get idPessoa => _idPessoa ?? 0;
  set idPessoa(int? val) => _idPessoa = val;

  void incrementIdPessoa(int amount) => idPessoa = idPessoa + amount;

  bool hasIdPessoa() => _idPessoa != null;

  static DependentesDatatypeStruct fromMap(Map<String, dynamic> data) =>
      DependentesDatatypeStruct(
        dtInclusao: data['dtInclusao'] as String?,
        dtCarencia: data['dtCarencia'] as String?,
        nmGrau: data['nmGrau'] as String?,
        nmPessoa: data['nmPessoa'] as String?,
        dtNascimento: data['dtNascimento'] as String?,
        nmVinculo: data['nmVinculo'] as String?,
        cdCPF: data['cdCPF'] as String?,
        idPessoa: castToType<int>(data['idPessoa']),
      );

  static DependentesDatatypeStruct? maybeFromMap(dynamic data) => data is Map
      ? DependentesDatatypeStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'dtInclusao': _dtInclusao,
        'dtCarencia': _dtCarencia,
        'nmGrau': _nmGrau,
        'nmPessoa': _nmPessoa,
        'dtNascimento': _dtNascimento,
        'nmVinculo': _nmVinculo,
        'cdCPF': _cdCPF,
        'idPessoa': _idPessoa,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'dtInclusao': serializeParam(
          _dtInclusao,
          ParamType.String,
        ),
        'dtCarencia': serializeParam(
          _dtCarencia,
          ParamType.String,
        ),
        'nmGrau': serializeParam(
          _nmGrau,
          ParamType.String,
        ),
        'nmPessoa': serializeParam(
          _nmPessoa,
          ParamType.String,
        ),
        'dtNascimento': serializeParam(
          _dtNascimento,
          ParamType.String,
        ),
        'nmVinculo': serializeParam(
          _nmVinculo,
          ParamType.String,
        ),
        'cdCPF': serializeParam(
          _cdCPF,
          ParamType.String,
        ),
        'idPessoa': serializeParam(
          _idPessoa,
          ParamType.int,
        ),
      }.withoutNulls;

  static DependentesDatatypeStruct fromSerializableMap(
          Map<String, dynamic> data) =>
      DependentesDatatypeStruct(
        dtInclusao: deserializeParam(
          data['dtInclusao'],
          ParamType.String,
          false,
        ),
        dtCarencia: deserializeParam(
          data['dtCarencia'],
          ParamType.String,
          false,
        ),
        nmGrau: deserializeParam(
          data['nmGrau'],
          ParamType.String,
          false,
        ),
        nmPessoa: deserializeParam(
          data['nmPessoa'],
          ParamType.String,
          false,
        ),
        dtNascimento: deserializeParam(
          data['dtNascimento'],
          ParamType.String,
          false,
        ),
        nmVinculo: deserializeParam(
          data['nmVinculo'],
          ParamType.String,
          false,
        ),
        cdCPF: deserializeParam(
          data['cdCPF'],
          ParamType.String,
          false,
        ),
        idPessoa: deserializeParam(
          data['idPessoa'],
          ParamType.int,
          false,
        ),
      );

  @override
  String toString() => 'DependentesDatatypeStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is DependentesDatatypeStruct &&
        dtInclusao == other.dtInclusao &&
        dtCarencia == other.dtCarencia &&
        nmGrau == other.nmGrau &&
        nmPessoa == other.nmPessoa &&
        dtNascimento == other.dtNascimento &&
        nmVinculo == other.nmVinculo &&
        cdCPF == other.cdCPF &&
        idPessoa == other.idPessoa;
  }

  @override
  int get hashCode => const ListEquality().hash([
        dtInclusao,
        dtCarencia,
        nmGrau,
        nmPessoa,
        dtNascimento,
        nmVinculo,
        cdCPF,
        idPessoa
      ]);
}

DependentesDatatypeStruct createDependentesDatatypeStruct({
  String? dtInclusao,
  String? dtCarencia,
  String? nmGrau,
  String? nmPessoa,
  String? dtNascimento,
  String? nmVinculo,
  String? cdCPF,
  int? idPessoa,
}) =>
    DependentesDatatypeStruct(
      dtInclusao: dtInclusao,
      dtCarencia: dtCarencia,
      nmGrau: nmGrau,
      nmPessoa: nmPessoa,
      dtNascimento: dtNascimento,
      nmVinculo: nmVinculo,
      cdCPF: cdCPF,
      idPessoa: idPessoa,
    );
