// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class HistoricoDataTypeStruct extends BaseStruct {
  HistoricoDataTypeStruct({
    int? id,
    int? statusId,
    String? categoria,
    int? usuarioId,
    int? responsavelId,
    String? dataHoraCriacao,
    String? observacao,
    int? tipoId,
    ResponsavelStruct? responsavel,
  })  : _id = id,
        _statusId = statusId,
        _categoria = categoria,
        _usuarioId = usuarioId,
        _responsavelId = responsavelId,
        _dataHoraCriacao = dataHoraCriacao,
        _observacao = observacao,
        _tipoId = tipoId,
        _responsavel = responsavel;

  // "id" field.
  int? _id;
  int get id => _id ?? 0;
  set id(int? val) => _id = val;

  void incrementId(int amount) => id = id + amount;

  bool hasId() => _id != null;

  // "status_id" field.
  int? _statusId;
  int get statusId => _statusId ?? 0;
  set statusId(int? val) => _statusId = val;

  void incrementStatusId(int amount) => statusId = statusId + amount;

  bool hasStatusId() => _statusId != null;

  // "categoria" field.
  String? _categoria;
  String get categoria => _categoria ?? '';
  set categoria(String? val) => _categoria = val;

  bool hasCategoria() => _categoria != null;

  // "usuario_id" field.
  int? _usuarioId;
  int get usuarioId => _usuarioId ?? 0;
  set usuarioId(int? val) => _usuarioId = val;

  void incrementUsuarioId(int amount) => usuarioId = usuarioId + amount;

  bool hasUsuarioId() => _usuarioId != null;

  // "responsavel_id" field.
  int? _responsavelId;
  int get responsavelId => _responsavelId ?? 0;
  set responsavelId(int? val) => _responsavelId = val;

  void incrementResponsavelId(int amount) =>
      responsavelId = responsavelId + amount;

  bool hasResponsavelId() => _responsavelId != null;

  // "data_hora_criacao" field.
  String? _dataHoraCriacao;
  String get dataHoraCriacao => _dataHoraCriacao ?? '';
  set dataHoraCriacao(String? val) => _dataHoraCriacao = val;

  bool hasDataHoraCriacao() => _dataHoraCriacao != null;

  // "observacao" field.
  String? _observacao;
  String get observacao => _observacao ?? '';
  set observacao(String? val) => _observacao = val;

  bool hasObservacao() => _observacao != null;

  // "tipo_id" field.
  int? _tipoId;
  int get tipoId => _tipoId ?? 0;
  set tipoId(int? val) => _tipoId = val;

  void incrementTipoId(int amount) => tipoId = tipoId + amount;

  bool hasTipoId() => _tipoId != null;

  // "responsavel" field.
  ResponsavelStruct? _responsavel;
  ResponsavelStruct get responsavel => _responsavel ?? ResponsavelStruct();
  set responsavel(ResponsavelStruct? val) => _responsavel = val;

  void updateResponsavel(Function(ResponsavelStruct) updateFn) {
    updateFn(_responsavel ??= ResponsavelStruct());
  }

  bool hasResponsavel() => _responsavel != null;

  static HistoricoDataTypeStruct fromMap(Map<String, dynamic> data) =>
      HistoricoDataTypeStruct(
        id: castToType<int>(data['id']),
        statusId: castToType<int>(data['status_id']),
        categoria: data['categoria'] as String?,
        usuarioId: castToType<int>(data['usuario_id']),
        responsavelId: castToType<int>(data['responsavel_id']),
        dataHoraCriacao: data['data_hora_criacao'] as String?,
        observacao: data['observacao'] as String?,
        tipoId: castToType<int>(data['tipo_id']),
        responsavel: data['responsavel'] is ResponsavelStruct
            ? data['responsavel']
            : ResponsavelStruct.maybeFromMap(data['responsavel']),
      );

  static HistoricoDataTypeStruct? maybeFromMap(dynamic data) => data is Map
      ? HistoricoDataTypeStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'id': _id,
        'status_id': _statusId,
        'categoria': _categoria,
        'usuario_id': _usuarioId,
        'responsavel_id': _responsavelId,
        'data_hora_criacao': _dataHoraCriacao,
        'observacao': _observacao,
        'tipo_id': _tipoId,
        'responsavel': _responsavel?.toMap(),
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'id': serializeParam(
          _id,
          ParamType.int,
        ),
        'status_id': serializeParam(
          _statusId,
          ParamType.int,
        ),
        'categoria': serializeParam(
          _categoria,
          ParamType.String,
        ),
        'usuario_id': serializeParam(
          _usuarioId,
          ParamType.int,
        ),
        'responsavel_id': serializeParam(
          _responsavelId,
          ParamType.int,
        ),
        'data_hora_criacao': serializeParam(
          _dataHoraCriacao,
          ParamType.String,
        ),
        'observacao': serializeParam(
          _observacao,
          ParamType.String,
        ),
        'tipo_id': serializeParam(
          _tipoId,
          ParamType.int,
        ),
        'responsavel': serializeParam(
          _responsavel,
          ParamType.DataStruct,
        ),
      }.withoutNulls;

  static HistoricoDataTypeStruct fromSerializableMap(
          Map<String, dynamic> data) =>
      HistoricoDataTypeStruct(
        id: deserializeParam(
          data['id'],
          ParamType.int,
          false,
        ),
        statusId: deserializeParam(
          data['status_id'],
          ParamType.int,
          false,
        ),
        categoria: deserializeParam(
          data['categoria'],
          ParamType.String,
          false,
        ),
        usuarioId: deserializeParam(
          data['usuario_id'],
          ParamType.int,
          false,
        ),
        responsavelId: deserializeParam(
          data['responsavel_id'],
          ParamType.int,
          false,
        ),
        dataHoraCriacao: deserializeParam(
          data['data_hora_criacao'],
          ParamType.String,
          false,
        ),
        observacao: deserializeParam(
          data['observacao'],
          ParamType.String,
          false,
        ),
        tipoId: deserializeParam(
          data['tipo_id'],
          ParamType.int,
          false,
        ),
        responsavel: deserializeStructParam(
          data['responsavel'],
          ParamType.DataStruct,
          false,
          structBuilder: ResponsavelStruct.fromSerializableMap,
        ),
      );

  @override
  String toString() => 'HistoricoDataTypeStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is HistoricoDataTypeStruct &&
        id == other.id &&
        statusId == other.statusId &&
        categoria == other.categoria &&
        usuarioId == other.usuarioId &&
        responsavelId == other.responsavelId &&
        dataHoraCriacao == other.dataHoraCriacao &&
        observacao == other.observacao &&
        tipoId == other.tipoId &&
        responsavel == other.responsavel;
  }

  @override
  int get hashCode => const ListEquality().hash([
        id,
        statusId,
        categoria,
        usuarioId,
        responsavelId,
        dataHoraCriacao,
        observacao,
        tipoId,
        responsavel
      ]);
}

HistoricoDataTypeStruct createHistoricoDataTypeStruct({
  int? id,
  int? statusId,
  String? categoria,
  int? usuarioId,
  int? responsavelId,
  String? dataHoraCriacao,
  String? observacao,
  int? tipoId,
  ResponsavelStruct? responsavel,
}) =>
    HistoricoDataTypeStruct(
      id: id,
      statusId: statusId,
      categoria: categoria,
      usuarioId: usuarioId,
      responsavelId: responsavelId,
      dataHoraCriacao: dataHoraCriacao,
      observacao: observacao,
      tipoId: tipoId,
      responsavel: responsavel ?? ResponsavelStruct(),
    );
