// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class JsonAnexosDataTypeStruct extends BaseStruct {
  JsonAnexosDataTypeStruct({
    String? name,
    List<int>? bytes,
    String? height,
    String? width,
    String? blurHash,
  })  : _name = name,
        _bytes = bytes,
        _height = height,
        _width = width,
        _blurHash = blurHash;

  // "name" field.
  String? _name;
  String get name => _name ?? '';
  set name(String? val) => _name = val;

  bool hasName() => _name != null;

  // "bytes" field.
  List<int>? _bytes;
  List<int> get bytes => _bytes ?? const [];
  set bytes(List<int>? val) => _bytes = val;

  void updateBytes(Function(List<int>) updateFn) {
    updateFn(_bytes ??= []);
  }

  bool hasBytes() => _bytes != null;

  // "height" field.
  String? _height;
  String get height => _height ?? '';
  set height(String? val) => _height = val;

  bool hasHeight() => _height != null;

  // "width" field.
  String? _width;
  String get width => _width ?? '';
  set width(String? val) => _width = val;

  bool hasWidth() => _width != null;

  // "blurHash" field.
  String? _blurHash;
  String get blurHash => _blurHash ?? '';
  set blurHash(String? val) => _blurHash = val;

  bool hasBlurHash() => _blurHash != null;

  static JsonAnexosDataTypeStruct fromMap(Map<String, dynamic> data) =>
      JsonAnexosDataTypeStruct(
        name: data['name'] as String?,
        bytes: getDataList(data['bytes']),
        height: data['height'] as String?,
        width: data['width'] as String?,
        blurHash: data['blurHash'] as String?,
      );

  static JsonAnexosDataTypeStruct? maybeFromMap(dynamic data) => data is Map
      ? JsonAnexosDataTypeStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'name': _name,
        'bytes': _bytes,
        'height': _height,
        'width': _width,
        'blurHash': _blurHash,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'name': serializeParam(
          _name,
          ParamType.String,
        ),
        'bytes': serializeParam(
          _bytes,
          ParamType.int,
          isList: true,
        ),
        'height': serializeParam(
          _height,
          ParamType.String,
        ),
        'width': serializeParam(
          _width,
          ParamType.String,
        ),
        'blurHash': serializeParam(
          _blurHash,
          ParamType.String,
        ),
      }.withoutNulls;

  static JsonAnexosDataTypeStruct fromSerializableMap(
          Map<String, dynamic> data) =>
      JsonAnexosDataTypeStruct(
        name: deserializeParam(
          data['name'],
          ParamType.String,
          false,
        ),
        bytes: deserializeParam<int>(
          data['bytes'],
          ParamType.int,
          true,
        ),
        height: deserializeParam(
          data['height'],
          ParamType.String,
          false,
        ),
        width: deserializeParam(
          data['width'],
          ParamType.String,
          false,
        ),
        blurHash: deserializeParam(
          data['blurHash'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'JsonAnexosDataTypeStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    const listEquality = ListEquality();
    return other is JsonAnexosDataTypeStruct &&
        name == other.name &&
        listEquality.equals(bytes, other.bytes) &&
        height == other.height &&
        width == other.width &&
        blurHash == other.blurHash;
  }

  @override
  int get hashCode =>
      const ListEquality().hash([name, bytes, height, width, blurHash]);
}

JsonAnexosDataTypeStruct createJsonAnexosDataTypeStruct({
  String? name,
  String? height,
  String? width,
  String? blurHash,
}) =>
    JsonAnexosDataTypeStruct(
      name: name,
      height: height,
      width: width,
      blurHash: blurHash,
    );
