// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class NotificacaoStruct extends BaseStruct {
  NotificacaoStruct({
    int? solicitacaoId,
    int? usuarioId,
    int? responsavelId,
    String? titulo,
    bool? lida,
    String? createdAt,
    int? id,
    String? mensagem,
    String? status,
  })  : _solicitacaoId = solicitacaoId,
        _usuarioId = usuarioId,
        _responsavelId = responsavelId,
        _titulo = titulo,
        _lida = lida,
        _createdAt = createdAt,
        _id = id,
        _mensagem = mensagem,
        _status = status;

  // "solicitacao_id" field.
  int? _solicitacaoId;
  int get solicitacaoId => _solicitacaoId ?? 0;
  set solicitacaoId(int? val) => _solicitacaoId = val;

  void incrementSolicitacaoId(int amount) =>
      solicitacaoId = solicitacaoId + amount;

  bool hasSolicitacaoId() => _solicitacaoId != null;

  // "usuario_id" field.
  int? _usuarioId;
  int get usuarioId => _usuarioId ?? 0;
  set usuarioId(int? val) => _usuarioId = val;

  void incrementUsuarioId(int amount) => usuarioId = usuarioId + amount;

  bool hasUsuarioId() => _usuarioId != null;

  // "responsavel_id" field.
  int? _responsavelId;
  int get responsavelId => _responsavelId ?? 0;
  set responsavelId(int? val) => _responsavelId = val;

  void incrementResponsavelId(int amount) =>
      responsavelId = responsavelId + amount;

  bool hasResponsavelId() => _responsavelId != null;

  // "titulo" field.
  String? _titulo;
  String get titulo => _titulo ?? '';
  set titulo(String? val) => _titulo = val;

  bool hasTitulo() => _titulo != null;

  // "lida" field.
  bool? _lida;
  bool get lida => _lida ?? false;
  set lida(bool? val) => _lida = val;

  bool hasLida() => _lida != null;

  // "created_at" field.
  String? _createdAt;
  String get createdAt => _createdAt ?? '';
  set createdAt(String? val) => _createdAt = val;

  bool hasCreatedAt() => _createdAt != null;

  // "id" field.
  int? _id;
  int get id => _id ?? 0;
  set id(int? val) => _id = val;

  void incrementId(int amount) => id = id + amount;

  bool hasId() => _id != null;

  // "mensagem" field.
  String? _mensagem;
  String get mensagem => _mensagem ?? '';
  set mensagem(String? val) => _mensagem = val;

  bool hasMensagem() => _mensagem != null;

  // "status" field.
  String? _status;
  String get status => _status ?? '';
  set status(String? val) => _status = val;

  bool hasStatus() => _status != null;

  static NotificacaoStruct fromMap(Map<String, dynamic> data) =>
      NotificacaoStruct(
        solicitacaoId: castToType<int>(data['solicitacao_id']),
        usuarioId: castToType<int>(data['usuario_id']),
        responsavelId: castToType<int>(data['responsavel_id']),
        titulo: data['titulo'] as String?,
        lida: data['lida'] as bool?,
        createdAt: data['created_at'] as String?,
        id: castToType<int>(data['id']),
        mensagem: data['mensagem'] as String?,
        status: data['status'] as String?,
      );

  static NotificacaoStruct? maybeFromMap(dynamic data) => data is Map
      ? NotificacaoStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'solicitacao_id': _solicitacaoId,
        'usuario_id': _usuarioId,
        'responsavel_id': _responsavelId,
        'titulo': _titulo,
        'lida': _lida,
        'created_at': _createdAt,
        'id': _id,
        'mensagem': _mensagem,
        'status': _status,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'solicitacao_id': serializeParam(
          _solicitacaoId,
          ParamType.int,
        ),
        'usuario_id': serializeParam(
          _usuarioId,
          ParamType.int,
        ),
        'responsavel_id': serializeParam(
          _responsavelId,
          ParamType.int,
        ),
        'titulo': serializeParam(
          _titulo,
          ParamType.String,
        ),
        'lida': serializeParam(
          _lida,
          ParamType.bool,
        ),
        'created_at': serializeParam(
          _createdAt,
          ParamType.String,
        ),
        'id': serializeParam(
          _id,
          ParamType.int,
        ),
        'mensagem': serializeParam(
          _mensagem,
          ParamType.String,
        ),
        'status': serializeParam(
          _status,
          ParamType.String,
        ),
      }.withoutNulls;

  static NotificacaoStruct fromSerializableMap(Map<String, dynamic> data) =>
      NotificacaoStruct(
        solicitacaoId: deserializeParam(
          data['solicitacao_id'],
          ParamType.int,
          false,
        ),
        usuarioId: deserializeParam(
          data['usuario_id'],
          ParamType.int,
          false,
        ),
        responsavelId: deserializeParam(
          data['responsavel_id'],
          ParamType.int,
          false,
        ),
        titulo: deserializeParam(
          data['titulo'],
          ParamType.String,
          false,
        ),
        lida: deserializeParam(
          data['lida'],
          ParamType.bool,
          false,
        ),
        createdAt: deserializeParam(
          data['created_at'],
          ParamType.String,
          false,
        ),
        id: deserializeParam(
          data['id'],
          ParamType.int,
          false,
        ),
        mensagem: deserializeParam(
          data['mensagem'],
          ParamType.String,
          false,
        ),
        status: deserializeParam(
          data['status'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'NotificacaoStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is NotificacaoStruct &&
        solicitacaoId == other.solicitacaoId &&
        usuarioId == other.usuarioId &&
        responsavelId == other.responsavelId &&
        titulo == other.titulo &&
        lida == other.lida &&
        createdAt == other.createdAt &&
        id == other.id &&
        mensagem == other.mensagem &&
        status == other.status;
  }

  @override
  int get hashCode => const ListEquality().hash([
        solicitacaoId,
        usuarioId,
        responsavelId,
        titulo,
        lida,
        createdAt,
        id,
        mensagem,
        status
      ]);
}

NotificacaoStruct createNotificacaoStruct({
  int? solicitacaoId,
  int? usuarioId,
  int? responsavelId,
  String? titulo,
  bool? lida,
  String? createdAt,
  int? id,
  String? mensagem,
  String? status,
}) =>
    NotificacaoStruct(
      solicitacaoId: solicitacaoId,
      usuarioId: usuarioId,
      responsavelId: responsavelId,
      titulo: titulo,
      lida: lida,
      createdAt: createdAt,
      id: id,
      mensagem: mensagem,
      status: status,
    );
