// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class RepresentanteStruct extends BaseStruct {
  RepresentanteStruct({
    String? nome,
    String? cpf,
    int? id,
    int? usuarioId,
  })  : _nome = nome,
        _cpf = cpf,
        _id = id,
        _usuarioId = usuarioId;

  // "nome" field.
  String? _nome;
  String get nome => _nome ?? '';
  set nome(String? val) => _nome = val;

  bool hasNome() => _nome != null;

  // "cpf" field.
  String? _cpf;
  String get cpf => _cpf ?? '';
  set cpf(String? val) => _cpf = val;

  bool hasCpf() => _cpf != null;

  // "id" field.
  int? _id;
  int get id => _id ?? 0;
  set id(int? val) => _id = val;

  void incrementId(int amount) => id = id + amount;

  bool hasId() => _id != null;

  // "usuario_id" field.
  int? _usuarioId;
  int get usuarioId => _usuarioId ?? 0;
  set usuarioId(int? val) => _usuarioId = val;

  void incrementUsuarioId(int amount) => usuarioId = usuarioId + amount;

  bool hasUsuarioId() => _usuarioId != null;

  static RepresentanteStruct fromMap(Map<String, dynamic> data) =>
      RepresentanteStruct(
        nome: data['nome'] as String?,
        cpf: data['cpf'] as String?,
        id: castToType<int>(data['id']),
        usuarioId: castToType<int>(data['usuario_id']),
      );

  static RepresentanteStruct? maybeFromMap(dynamic data) => data is Map
      ? RepresentanteStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'nome': _nome,
        'cpf': _cpf,
        'id': _id,
        'usuario_id': _usuarioId,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'nome': serializeParam(
          _nome,
          ParamType.String,
        ),
        'cpf': serializeParam(
          _cpf,
          ParamType.String,
        ),
        'id': serializeParam(
          _id,
          ParamType.int,
        ),
        'usuario_id': serializeParam(
          _usuarioId,
          ParamType.int,
        ),
      }.withoutNulls;

  static RepresentanteStruct fromSerializableMap(Map<String, dynamic> data) =>
      RepresentanteStruct(
        nome: deserializeParam(
          data['nome'],
          ParamType.String,
          false,
        ),
        cpf: deserializeParam(
          data['cpf'],
          ParamType.String,
          false,
        ),
        id: deserializeParam(
          data['id'],
          ParamType.int,
          false,
        ),
        usuarioId: deserializeParam(
          data['usuario_id'],
          ParamType.int,
          false,
        ),
      );

  @override
  String toString() => 'RepresentanteStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is RepresentanteStruct &&
        nome == other.nome &&
        cpf == other.cpf &&
        id == other.id &&
        usuarioId == other.usuarioId;
  }

  @override
  int get hashCode => const ListEquality().hash([nome, cpf, id, usuarioId]);
}

RepresentanteStruct createRepresentanteStruct({
  String? nome,
  String? cpf,
  int? id,
  int? usuarioId,
}) =>
    RepresentanteStruct(
      nome: nome,
      cpf: cpf,
      id: id,
      usuarioId: usuarioId,
    );
