// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class ResponsavelStruct extends BaseStruct {
  ResponsavelStruct({
    String? name,
    String? avatar,
  })  : _name = name,
        _avatar = avatar;

  // "name" field.
  String? _name;
  String get name => _name ?? '';
  set name(String? val) => _name = val;

  bool hasName() => _name != null;

  // "avatar" field.
  String? _avatar;
  String get avatar => _avatar ?? '';
  set avatar(String? val) => _avatar = val;

  bool hasAvatar() => _avatar != null;

  static ResponsavelStruct fromMap(Map<String, dynamic> data) =>
      ResponsavelStruct(
        name: data['name'] as String?,
        avatar: data['avatar'] as String?,
      );

  static ResponsavelStruct? maybeFromMap(dynamic data) => data is Map
      ? ResponsavelStruct.fromMap(data.cast<String, dynamic>())
      : null;

  Map<String, dynamic> toMap() => {
        'name': _name,
        'avatar': _avatar,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'name': serializeParam(
          _name,
          ParamType.String,
        ),
        'avatar': serializeParam(
          _avatar,
          ParamType.String,
        ),
      }.withoutNulls;

  static ResponsavelStruct fromSerializableMap(Map<String, dynamic> data) =>
      ResponsavelStruct(
        name: deserializeParam(
          data['name'],
          ParamType.String,
          false,
        ),
        avatar: deserializeParam(
          data['avatar'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'ResponsavelStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is ResponsavelStruct &&
        name == other.name &&
        avatar == other.avatar;
  }

  @override
  int get hashCode => const ListEquality().hash([name, avatar]);
}

ResponsavelStruct createResponsavelStruct({
  String? name,
  String? avatar,
}) =>
    ResponsavelStruct(
      name: name,
      avatar: avatar,
    );
