// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class ResultadoCadastroRepresentanteStruct extends BaseStruct {
  ResultadoCadastroRepresentanteStruct({
    String? nome,
    String? cpf,
    String? parentesco,
    String? dataNascimento,
    int? id,
    int? usuarioId,
  })  : _nome = nome,
        _cpf = cpf,
        _parentesco = parentesco,
        _dataNascimento = dataNascimento,
        _id = id,
        _usuarioId = usuarioId;

  // "nome" field.
  String? _nome;
  String get nome => _nome ?? '';
  set nome(String? val) => _nome = val;

  bool hasNome() => _nome != null;

  // "cpf" field.
  String? _cpf;
  String get cpf => _cpf ?? '';
  set cpf(String? val) => _cpf = val;

  bool hasCpf() => _cpf != null;

  // "parentesco" field.
  String? _parentesco;
  String get parentesco => _parentesco ?? '';
  set parentesco(String? val) => _parentesco = val;

  bool hasParentesco() => _parentesco != null;

  // "data_nascimento" field.
  String? _dataNascimento;
  String get dataNascimento => _dataNascimento ?? '';
  set dataNascimento(String? val) => _dataNascimento = val;

  bool hasDataNascimento() => _dataNascimento != null;

  // "id" field.
  int? _id;
  int get id => _id ?? 0;
  set id(int? val) => _id = val;

  void incrementId(int amount) => id = id + amount;

  bool hasId() => _id != null;

  // "usuario_id" field.
  int? _usuarioId;
  int get usuarioId => _usuarioId ?? 0;
  set usuarioId(int? val) => _usuarioId = val;

  void incrementUsuarioId(int amount) => usuarioId = usuarioId + amount;

  bool hasUsuarioId() => _usuarioId != null;

  static ResultadoCadastroRepresentanteStruct fromMap(
          Map<String, dynamic> data) =>
      ResultadoCadastroRepresentanteStruct(
        nome: data['nome'] as String?,
        cpf: data['cpf'] as String?,
        parentesco: data['parentesco'] as String?,
        dataNascimento: data['data_nascimento'] as String?,
        id: castToType<int>(data['id']),
        usuarioId: castToType<int>(data['usuario_id']),
      );

  static ResultadoCadastroRepresentanteStruct? maybeFromMap(dynamic data) =>
      data is Map
          ? ResultadoCadastroRepresentanteStruct.fromMap(
              data.cast<String, dynamic>())
          : null;

  Map<String, dynamic> toMap() => {
        'nome': _nome,
        'cpf': _cpf,
        'parentesco': _parentesco,
        'data_nascimento': _dataNascimento,
        'id': _id,
        'usuario_id': _usuarioId,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'nome': serializeParam(
          _nome,
          ParamType.String,
        ),
        'cpf': serializeParam(
          _cpf,
          ParamType.String,
        ),
        'parentesco': serializeParam(
          _parentesco,
          ParamType.String,
        ),
        'data_nascimento': serializeParam(
          _dataNascimento,
          ParamType.String,
        ),
        'id': serializeParam(
          _id,
          ParamType.int,
        ),
        'usuario_id': serializeParam(
          _usuarioId,
          ParamType.int,
        ),
      }.withoutNulls;

  static ResultadoCadastroRepresentanteStruct fromSerializableMap(
          Map<String, dynamic> data) =>
      ResultadoCadastroRepresentanteStruct(
        nome: deserializeParam(
          data['nome'],
          ParamType.String,
          false,
        ),
        cpf: deserializeParam(
          data['cpf'],
          ParamType.String,
          false,
        ),
        parentesco: deserializeParam(
          data['parentesco'],
          ParamType.String,
          false,
        ),
        dataNascimento: deserializeParam(
          data['data_nascimento'],
          ParamType.String,
          false,
        ),
        id: deserializeParam(
          data['id'],
          ParamType.int,
          false,
        ),
        usuarioId: deserializeParam(
          data['usuario_id'],
          ParamType.int,
          false,
        ),
      );

  @override
  String toString() => 'ResultadoCadastroRepresentanteStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is ResultadoCadastroRepresentanteStruct &&
        nome == other.nome &&
        cpf == other.cpf &&
        parentesco == other.parentesco &&
        dataNascimento == other.dataNascimento &&
        id == other.id &&
        usuarioId == other.usuarioId;
  }

  @override
  int get hashCode => const ListEquality()
      .hash([nome, cpf, parentesco, dataNascimento, id, usuarioId]);
}

ResultadoCadastroRepresentanteStruct
    createResultadoCadastroRepresentanteStruct({
  String? nome,
  String? cpf,
  String? parentesco,
  String? dataNascimento,
  int? id,
  int? usuarioId,
}) =>
        ResultadoCadastroRepresentanteStruct(
          nome: nome,
          cpf: cpf,
          parentesco: parentesco,
          dataNascimento: dataNascimento,
          id: id,
          usuarioId: usuarioId,
        );
