// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class SubStruct extends BaseStruct {
  SubStruct({
    int? id,
    String? nome,
    String? email,
    String? cpf,
  })  : _id = id,
        _nome = nome,
        _email = email,
        _cpf = cpf;

  // "id" field.
  int? _id;
  int get id => _id ?? 0;
  set id(int? val) => _id = val;

  void incrementId(int amount) => id = id + amount;

  bool hasId() => _id != null;

  // "nome" field.
  String? _nome;
  String get nome => _nome ?? '';
  set nome(String? val) => _nome = val;

  bool hasNome() => _nome != null;

  // "email" field.
  String? _email;
  String get email => _email ?? '';
  set email(String? val) => _email = val;

  bool hasEmail() => _email != null;

  // "cpf" field.
  String? _cpf;
  String get cpf => _cpf ?? '';
  set cpf(String? val) => _cpf = val;

  bool hasCpf() => _cpf != null;

  static SubStruct fromMap(Map<String, dynamic> data) => SubStruct(
        id: castToType<int>(data['id']),
        nome: data['nome'] as String?,
        email: data['email'] as String?,
        cpf: data['cpf'] as String?,
      );

  static SubStruct? maybeFromMap(dynamic data) =>
      data is Map ? SubStruct.fromMap(data.cast<String, dynamic>()) : null;

  Map<String, dynamic> toMap() => {
        'id': _id,
        'nome': _nome,
        'email': _email,
        'cpf': _cpf,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'id': serializeParam(
          _id,
          ParamType.int,
        ),
        'nome': serializeParam(
          _nome,
          ParamType.String,
        ),
        'email': serializeParam(
          _email,
          ParamType.String,
        ),
        'cpf': serializeParam(
          _cpf,
          ParamType.String,
        ),
      }.withoutNulls;

  static SubStruct fromSerializableMap(Map<String, dynamic> data) => SubStruct(
        id: deserializeParam(
          data['id'],
          ParamType.int,
          false,
        ),
        nome: deserializeParam(
          data['nome'],
          ParamType.String,
          false,
        ),
        email: deserializeParam(
          data['email'],
          ParamType.String,
          false,
        ),
        cpf: deserializeParam(
          data['cpf'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'SubStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is SubStruct &&
        id == other.id &&
        nome == other.nome &&
        email == other.email &&
        cpf == other.cpf;
  }

  @override
  int get hashCode => const ListEquality().hash([id, nome, email, cpf]);
}

SubStruct createSubStruct({
  int? id,
  String? nome,
  String? email,
  String? cpf,
}) =>
    SubStruct(
      id: id,
      nome: nome,
      email: email,
      cpf: cpf,
    );
