// ignore_for_file: unnecessary_getters_setters

import '/backend/schema/util/schema_util.dart';

import 'index.dart';
import '/flutter_flow/flutter_flow_util.dart';

class UsuarioStruct extends BaseStruct {
  UsuarioStruct({
    int? id,
    String? nomeCompleto,
    String? email,
    String? cpf,
  })  : _id = id,
        _nomeCompleto = nomeCompleto,
        _email = email,
        _cpf = cpf;

  // "id" field.
  int? _id;
  int get id => _id ?? 0;
  set id(int? val) => _id = val;

  void incrementId(int amount) => id = id + amount;

  bool hasId() => _id != null;

  // "nome_completo" field.
  String? _nomeCompleto;
  String get nomeCompleto => _nomeCompleto ?? '';
  set nomeCompleto(String? val) => _nomeCompleto = val;

  bool hasNomeCompleto() => _nomeCompleto != null;

  // "email" field.
  String? _email;
  String get email => _email ?? '';
  set email(String? val) => _email = val;

  bool hasEmail() => _email != null;

  // "cpf" field.
  String? _cpf;
  String get cpf => _cpf ?? '';
  set cpf(String? val) => _cpf = val;

  bool hasCpf() => _cpf != null;

  static UsuarioStruct fromMap(Map<String, dynamic> data) => UsuarioStruct(
        id: castToType<int>(data['id']),
        nomeCompleto: data['nome_completo'] as String?,
        email: data['email'] as String?,
        cpf: data['cpf'] as String?,
      );

  static UsuarioStruct? maybeFromMap(dynamic data) =>
      data is Map ? UsuarioStruct.fromMap(data.cast<String, dynamic>()) : null;

  Map<String, dynamic> toMap() => {
        'id': _id,
        'nome_completo': _nomeCompleto,
        'email': _email,
        'cpf': _cpf,
      }.withoutNulls;

  @override
  Map<String, dynamic> toSerializableMap() => {
        'id': serializeParam(
          _id,
          ParamType.int,
        ),
        'nome_completo': serializeParam(
          _nomeCompleto,
          ParamType.String,
        ),
        'email': serializeParam(
          _email,
          ParamType.String,
        ),
        'cpf': serializeParam(
          _cpf,
          ParamType.String,
        ),
      }.withoutNulls;

  static UsuarioStruct fromSerializableMap(Map<String, dynamic> data) =>
      UsuarioStruct(
        id: deserializeParam(
          data['id'],
          ParamType.int,
          false,
        ),
        nomeCompleto: deserializeParam(
          data['nome_completo'],
          ParamType.String,
          false,
        ),
        email: deserializeParam(
          data['email'],
          ParamType.String,
          false,
        ),
        cpf: deserializeParam(
          data['cpf'],
          ParamType.String,
          false,
        ),
      );

  @override
  String toString() => 'UsuarioStruct(${toMap()})';

  @override
  bool operator ==(Object other) {
    return other is UsuarioStruct &&
        id == other.id &&
        nomeCompleto == other.nomeCompleto &&
        email == other.email &&
        cpf == other.cpf;
  }

  @override
  int get hashCode => const ListEquality().hash([id, nomeCompleto, email, cpf]);
}

UsuarioStruct createUsuarioStruct({
  int? id,
  String? nomeCompleto,
  String? email,
  String? cpf,
}) =>
    UsuarioStruct(
      id: id,
      nomeCompleto: nomeCompleto,
      email: email,
      cpf: cpf,
    );
