import '/backend/api_requests/api_calls.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';
import 'aviso4_model.dart';
export 'aviso4_model.dart';

class Aviso4Widget extends StatefulWidget {
  const Aviso4Widget({
    super.key,
    required this.nomedependente,
    required this.cpfdependente,
    required this.parentenscodependente,
    required this.datanascimentodependente,
    required this.iddependente,
  });

  final String? nomedependente;
  final String? cpfdependente;
  final String? parentenscodependente;
  final String? datanascimentodependente;
  final String? iddependente;

  @override
  State<Aviso4Widget> createState() => _Aviso4WidgetState();
}

class _Aviso4WidgetState extends State<Aviso4Widget> {
  late Aviso4Model _model;

  @override
  void setState(VoidCallback callback) {
    super.setState(callback);
    _model.onUpdate();
  }

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => Aviso4Model());

    WidgetsBinding.instance.addPostFrameCallback((_) => safeSetState(() {}));
  }

  @override
  void dispose() {
    _model.maybeDispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    context.watch<FFAppState>();

    return Align(
      alignment: AlignmentDirectional(0.0, 0.0),
      child: Padding(
        padding: EdgeInsetsDirectional.fromSTEB(16.0, 12.0, 16.0, 12.0),
        child: Container(
          width: double.infinity,
          constraints: BoxConstraints(
            maxWidth: 530.0,
            maxHeight: 350.0,
          ),
          decoration: BoxDecoration(
            color: FlutterFlowTheme.of(context).secondaryBackground,
            boxShadow: [
              BoxShadow(
                blurRadius: 3.0,
                color: Color(0x33000000),
                offset: Offset(
                  0.0,
                  1.0,
                ),
              )
            ],
            borderRadius: BorderRadius.circular(24.0),
            border: Border.all(
              color: FlutterFlowTheme.of(context).primaryBackground,
              width: 1.0,
            ),
          ),
          child: Padding(
            padding: EdgeInsetsDirectional.fromSTEB(0.0, 0.0, 0.0, 12.0),
            child: Column(
              mainAxisSize: MainAxisSize.max,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Padding(
                  padding:
                      EdgeInsetsDirectional.fromSTEB(24.0, 16.0, 24.0, 16.0),
                  child: Column(
                    mainAxisSize: MainAxisSize.max,
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: [
                      Align(
                        alignment: AlignmentDirectional(0.0, 0.0),
                        child: Icon(
                          Icons.do_not_disturb_on,
                          color: FlutterFlowTheme.of(context).error,
                          size: 120.0,
                        ),
                      ),
                      Align(
                        alignment: AlignmentDirectional(0.0, 0.0),
                        child: Text(
                          'Remover dependente?',
                          textAlign: TextAlign.center,
                          style: FlutterFlowTheme.of(context)
                              .headlineMedium
                              .override(
                                fontFamily: 'Inter Tight',
                                fontSize: 18.0,
                                letterSpacing: 0.0,
                              ),
                        ),
                      ),
                      Padding(
                        padding:
                            EdgeInsetsDirectional.fromSTEB(0.0, 12.0, 0.0, 0.0),
                        child: Text(
                          'Deseja remover',
                          textAlign: TextAlign.center,
                          style:
                              FlutterFlowTheme.of(context).labelMedium.override(
                                    fontFamily: 'Inter',
                                    letterSpacing: 0.0,
                                  ),
                        ),
                      ),
                      Padding(
                        padding:
                            EdgeInsetsDirectional.fromSTEB(0.0, 3.0, 0.0, 0.0),
                        child: Text(
                          valueOrDefault<String>(
                            widget!.nomedependente,
                            'Não definido',
                          ),
                          textAlign: TextAlign.center,
                          style:
                              FlutterFlowTheme.of(context).labelMedium.override(
                                    fontFamily: 'Inter',
                                    letterSpacing: 0.0,
                                    fontWeight: FontWeight.bold,
                                  ),
                        ),
                      ),
                      Padding(
                        padding:
                            EdgeInsetsDirectional.fromSTEB(0.0, 3.0, 0.0, 0.0),
                        child: Text(
                          'dos seus dependentes?',
                          textAlign: TextAlign.center,
                          style:
                              FlutterFlowTheme.of(context).labelMedium.override(
                                    fontFamily: 'Inter',
                                    letterSpacing: 0.0,
                                  ),
                        ),
                      ),
                    ],
                  ),
                ),
                Padding(
                  padding:
                      EdgeInsetsDirectional.fromSTEB(24.0, 20.0, 24.0, 5.0),
                  child: Row(
                    mainAxisSize: MainAxisSize.max,
                    mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                    children: [
                      FFButtonWidget(
                        onPressed: () async {
                          _model.apiResultObterDependentes =
                              await GrupoAPIAvantinoIGroup
                                  .beneficiariosIDContratoCall
                                  .call(
                            idCont: FFAppState().idselecionado,
                            token: FFAppState().avantToken,
                            dominio: 'cje',
                          );

                          FFAppState().novosdadostempdependentes =
                              functions.dependenteToJson(
                                  widget!.nomedependente,
                                  functions.cpfNoMask(widget!.cpfdependente!),
                                  widget!.parentenscodependente,
                                  functions.formatDateToDB(
                                      widget!.datanascimentodependente!),
                                  widget!.iddependente)!;
                          FFAppState().solicitacaoexcluirdependente =
                              functions.montaJsonIncluirDependente(
                                  '8',
                                  FFAppState().userId.toString(),
                                  true,
                                  true,
                                  'Dependente')!;
                          FFAppState().dadosatuaistempdependentes =
                              functions.dependenteToJsonLista(
                                  (getJsonField(
                                    (_model.apiResultObterDependentes
                                            ?.jsonBody ??
                                        ''),
                                    r'''$[:].nmPessoa''',
                                    true,
                                  ) as List)
                                      .map<String>((s) => s.toString())
                                      .toList(),
                                  (getJsonField(
                                    (_model.apiResultObterDependentes
                                            ?.jsonBody ??
                                        ''),
                                    r'''$[:].cdCPF''',
                                    true,
                                  ) as List)
                                      .map<String>((s) => s.toString())
                                      .toList(),
                                  (getJsonField(
                                    (_model.apiResultObterDependentes
                                            ?.jsonBody ??
                                        ''),
                                    r'''$[:].nmGrau''',
                                    true,
                                  ) as List)
                                      .map<String>((s) => s.toString())
                                      .toList(),
                                  (getJsonField(
                                    (_model.apiResultObterDependentes
                                            ?.jsonBody ??
                                        ''),
                                    r'''$[:].dtNascimento''',
                                    true,
                                  ) as List)
                                      .map<String>((s) => s.toString())
                                      .toList(),
                                  (getJsonField(
                                    (_model.apiResultObterDependentes
                                            ?.jsonBody ??
                                        ''),
                                    r'''$[:].idPessoa''',
                                    true,
                                  ) as List)
                                      .map<String>((s) => s.toString())
                                      .toList())!;
                          safeSetState(() {});
                          _model.apiResultExcluirDependente =
                              await ServidorJardimUsuariosGroup
                                  .solicitacaoExcluirDependenteCall
                                  .call(
                            dadosconfJson:
                                FFAppState().solicitacaoexcluirdependente,
                            dadosatuaisJson:
                                FFAppState().dadosatuaistempdependentes,
                            dadosnovosJson:
                                FFAppState().novosdadostempdependentes,
                            token: FFAppState().userToken,
                          );

                          if ((_model.apiResultExcluirDependente?.succeeded ??
                              true)) {
                            await showDialog(
                              context: context,
                              builder: (alertDialogContext) {
                                return AlertDialog(
                                  content: Text(
                                      'Solicitação de exclusão enviada para análise.'),
                                  actions: [
                                    TextButton(
                                      onPressed: () =>
                                          Navigator.pop(alertDialogContext),
                                      child: Text('Ok'),
                                    ),
                                  ],
                                );
                              },
                            );
                            Navigator.pop(context);
                          } else {
                            await showDialog(
                              context: context,
                              builder: (alertDialogContext) {
                                return AlertDialog(
                                  content: Text(
                                      'Não foi possível realizar a solicitação!'),
                                  actions: [
                                    TextButton(
                                      onPressed: () =>
                                          Navigator.pop(alertDialogContext),
                                      child: Text('Ok'),
                                    ),
                                  ],
                                );
                              },
                            );
                          }

                          safeSetState(() {});
                        },
                        text: 'Sim',
                        options: FFButtonOptions(
                          height: 30.0,
                          padding: EdgeInsetsDirectional.fromSTEB(
                              20.0, 0.0, 20.0, 0.0),
                          iconPadding: EdgeInsetsDirectional.fromSTEB(
                              0.0, 0.0, 0.0, 0.0),
                          color: Color(0xFF007A3B),
                          textStyle:
                              FlutterFlowTheme.of(context).titleSmall.override(
                                    fontFamily: 'Inter Tight',
                                    color: FlutterFlowTheme.of(context)
                                        .primaryBackground,
                                    letterSpacing: 0.0,
                                  ),
                          elevation: 0.0,
                          borderSide: BorderSide(
                            color: Colors.transparent,
                          ),
                          borderRadius: BorderRadius.circular(8.0),
                        ),
                      ),
                      FFButtonWidget(
                        onPressed: () async {
                          FFAppState().ciente = false;
                          safeSetState(() {});
                          Navigator.pop(context);
                        },
                        text: 'Não',
                        options: FFButtonOptions(
                          height: 30.0,
                          padding: EdgeInsetsDirectional.fromSTEB(
                              20.0, 0.0, 20.0, 0.0),
                          iconPadding: EdgeInsetsDirectional.fromSTEB(
                              0.0, 0.0, 0.0, 0.0),
                          color: Color(0xFFE83C2C),
                          textStyle:
                              FlutterFlowTheme.of(context).titleSmall.override(
                                    fontFamily: 'Inter Tight',
                                    color: FlutterFlowTheme.of(context)
                                        .primaryBackground,
                                    letterSpacing: 0.0,
                                  ),
                          elevation: 0.0,
                          borderSide: BorderSide(
                            color: Colors.transparent,
                          ),
                          borderRadius: BorderRadius.circular(8.0),
                        ),
                      ),
                    ],
                  ),
                ),
              ],
            ),
          ),
        ),
      ),
    );
  }
}
