import '/components/aviso4_widget.dart';
import '/components/aviso6_widget.dart';
import '/flutter_flow/flutter_flow_icon_button.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'package:auto_size_text/auto_size_text.dart';
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:font_awesome_flutter/font_awesome_flutter.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';
import 'dependentes_card_model.dart';
export 'dependentes_card_model.dart';

class DependentesCardWidget extends StatefulWidget {
  const DependentesCardWidget({
    super.key,
    this.nomepessoaD,
    this.vinculoD,
    this.parentescoD,
    this.inclusaoD,
    this.nascimentoD,
    this.fimcarenciaD,
    required this.cpfD,
    required this.iddependenteD,
    this.solicitacaoidD,
    this.tipoidD,
  });

  final String? nomepessoaD;
  final String? vinculoD;
  final String? parentescoD;
  final String? inclusaoD;
  final String? nascimentoD;
  final String? fimcarenciaD;
  final String? cpfD;
  final int? iddependenteD;
  final int? solicitacaoidD;
  final int? tipoidD;

  @override
  State<DependentesCardWidget> createState() => _DependentesCardWidgetState();
}

class _DependentesCardWidgetState extends State<DependentesCardWidget> {
  late DependentesCardModel _model;

  @override
  void setState(VoidCallback callback) {
    super.setState(callback);
    _model.onUpdate();
  }

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => DependentesCardModel());

    WidgetsBinding.instance.addPostFrameCallback((_) => safeSetState(() {}));
  }

  @override
  void dispose() {
    _model.maybeDispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Card(
      clipBehavior: Clip.antiAliasWithSaveLayer,
      color: Color(0xFFEFEBEA),
      elevation: 3.0,
      shape: RoundedRectangleBorder(
        borderRadius: BorderRadius.circular(10.0),
      ),
      child: Container(
        width: double.infinity,
        decoration: BoxDecoration(),
        child: Column(
          mainAxisSize: MainAxisSize.max,
          children: [
            Padding(
              padding: EdgeInsetsDirectional.fromSTEB(0.0, 10.0, 10.0, 0.0),
              child: Row(
                mainAxisSize: MainAxisSize.max,
                mainAxisAlignment: MainAxisAlignment.end,
                children: [
                  Align(
                    alignment: AlignmentDirectional(1.0, 0.0),
                    child: FlutterFlowIconButton(
                      borderRadius: 12.0,
                      buttonSize: 30.0,
                      fillColor: FlutterFlowTheme.of(context).primary,
                      icon: Icon(
                        Icons.mode_edit_outlined,
                        color: FlutterFlowTheme.of(context).info,
                        size: 14.0,
                      ),
                      onPressed: () async {
                        if ((widget!.tipoidD == 4) ||
                            (widget!.tipoidD == 3) ||
                            (widget!.tipoidD == 8)) {
                          context.pushNamed(
                            'AlterarDependenteSolicitacao',
                            queryParameters: {
                              'nomecompleto': serializeParam(
                                widget!.nomepessoaD,
                                ParamType.String,
                              ),
                              'grauparentescoeditar': serializeParam(
                                widget!.parentescoD,
                                ParamType.String,
                              ),
                              'datanascimentoeditar': serializeParam(
                                widget!.nascimentoD,
                                ParamType.String,
                              ),
                              'cpfeditar': serializeParam(
                                widget!.cpfD,
                                ParamType.String,
                              ),
                              'ideditar': serializeParam(
                                widget!.iddependenteD?.toString(),
                                ParamType.String,
                              ),
                              'solicitacaoid': serializeParam(
                                widget!.solicitacaoidD,
                                ParamType.int,
                              ),
                            }.withoutNulls,
                          );
                        } else {
                          context.pushNamed(
                            'AlterarDependente',
                            queryParameters: {
                              'nomecompleto': serializeParam(
                                widget!.nomepessoaD,
                                ParamType.String,
                              ),
                              'grauparentescoeditar': serializeParam(
                                widget!.parentescoD,
                                ParamType.String,
                              ),
                              'datanascimentoeditar': serializeParam(
                                widget!.nascimentoD,
                                ParamType.String,
                              ),
                              'cpfeditar': serializeParam(
                                widget!.cpfD,
                                ParamType.String,
                              ),
                              'ideditar': serializeParam(
                                widget!.iddependenteD?.toString(),
                                ParamType.String,
                              ),
                            }.withoutNulls,
                          );
                        }
                      },
                    ),
                  ),
                  Align(
                    alignment: AlignmentDirectional(1.0, 0.0),
                    child: FlutterFlowIconButton(
                      borderRadius: 12.0,
                      buttonSize: 30.0,
                      fillColor: FlutterFlowTheme.of(context).error,
                      icon: FaIcon(
                        FontAwesomeIcons.trashAlt,
                        color: FlutterFlowTheme.of(context).primaryBackground,
                        size: 14.0,
                      ),
                      onPressed: () async {
                        if ((widget!.tipoidD == 8) ||
                            (widget!.tipoidD == 3) ||
                            (widget!.tipoidD == 4)) {
                          await showModalBottomSheet(
                            isScrollControlled: true,
                            backgroundColor: Colors.transparent,
                            enableDrag: false,
                            context: context,
                            builder: (context) {
                              return Padding(
                                padding: MediaQuery.viewInsetsOf(context),
                                child: Aviso6Widget(
                                  nomedependente: widget!.nomepessoaD!,
                                  cpfdependente:
                                      functions.cpfNoMask(widget!.cpfD!)!,
                                  parentenscodependente: widget!.parentescoD!,
                                  datanascimentodependente: functions
                                      .formatDateToDB(widget!.nascimentoD!),
                                  iddependente:
                                      widget!.iddependenteD!.toString(),
                                  solicitacaoid: widget!.solicitacaoidD!,
                                ),
                              );
                            },
                          ).then((value) => safeSetState(() {}));
                        } else {
                          await showModalBottomSheet(
                            isScrollControlled: true,
                            backgroundColor: Colors.transparent,
                            enableDrag: false,
                            context: context,
                            builder: (context) {
                              return Padding(
                                padding: MediaQuery.viewInsetsOf(context),
                                child: Aviso4Widget(
                                  nomedependente: widget!.nomepessoaD!,
                                  cpfdependente: widget!.cpfD!,
                                  parentenscodependente: widget!.parentescoD!,
                                  datanascimentodependente:
                                      widget!.nascimentoD!,
                                  iddependente:
                                      widget!.iddependenteD!.toString(),
                                ),
                              );
                            },
                          ).then((value) => safeSetState(() {}));
                        }
                      },
                    ),
                  ),
                ].divide(SizedBox(width: 5.0)),
              ),
            ),
            Padding(
              padding: EdgeInsetsDirectional.fromSTEB(15.0, 0.0, 15.0, 15.0),
              child: Row(
                mainAxisSize: MainAxisSize.max,
                mainAxisAlignment: MainAxisAlignment.start,
                crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                  Flexible(
                    child: Column(
                      mainAxisSize: MainAxisSize.max,
                      children: [
                        Padding(
                          padding: EdgeInsetsDirectional.fromSTEB(
                              0.0, 0.0, 0.0, 3.0),
                          child: ClipRRect(
                            borderRadius: BorderRadius.circular(24.0),
                            child: Image.asset(
                              'assets/images/Perfil_sem_foto_amarelo.png',
                              width: 55.0,
                              height: 55.0,
                              fit: BoxFit.cover,
                            ),
                          ),
                        ),
                      ],
                    ),
                  ),
                  Flexible(
                    flex: 2,
                    child: Padding(
                      padding:
                          EdgeInsetsDirectional.fromSTEB(0.0, 0.0, 0.0, 3.0),
                      child: Column(
                        mainAxisSize: MainAxisSize.max,
                        mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: [
                          Row(
                            mainAxisSize: MainAxisSize.max,
                            children: [
                              Flexible(
                                child: Padding(
                                  padding: EdgeInsetsDirectional.fromSTEB(
                                      10.0, 0.0, 0.0, 0.0),
                                  child: AutoSizeText(
                                    valueOrDefault<String>(
                                      widget!.nomepessoaD,
                                      'Não definido',
                                    ),
                                    textAlign: TextAlign.start,
                                    style: FlutterFlowTheme.of(context)
                                        .bodyMedium
                                        .override(
                                          fontFamily: 'Montserrat',
                                          fontSize: 14.0,
                                          letterSpacing: 0.0,
                                          fontWeight: FontWeight.bold,
                                        ),
                                  ),
                                ),
                              ),
                            ],
                          ),
                          Padding(
                            padding: EdgeInsetsDirectional.fromSTEB(
                                10.0, 3.0, 0.0, 0.0),
                            child: Container(
                              width: 153.0,
                              height: 24.0,
                              decoration: BoxDecoration(
                                color: widget!.vinculoD == 'PROCURADOR'
                                    ? Color(0xFFF36B6B)
                                    : Color(0xFF7B4848),
                                borderRadius: BorderRadius.circular(6.0),
                                shape: BoxShape.rectangle,
                              ),
                              alignment: AlignmentDirectional(0.0, 0.0),
                              child: Text(
                                valueOrDefault<String>(
                                  widget!.vinculoD,
                                  'Não definido',
                                ),
                                style: FlutterFlowTheme.of(context)
                                    .bodyMedium
                                    .override(
                                      fontFamily: 'Inter',
                                      color: widget!.vinculoD == 'PROCURADOR'
                                          ? FlutterFlowTheme.of(context)
                                              .primaryText
                                          : FlutterFlowTheme.of(context)
                                              .primaryBackground,
                                      fontSize: 11.0,
                                      letterSpacing: 0.0,
                                      fontWeight: FontWeight.bold,
                                    ),
                              ),
                            ),
                          ),
                        ].divide(SizedBox(height: 10.0)),
                      ),
                    ),
                  ),
                ],
              ),
            ),
            Padding(
              padding: EdgeInsetsDirectional.fromSTEB(15.0, 0.0, 15.0, 10.0),
              child: Row(
                mainAxisSize: MainAxisSize.max,
                mainAxisAlignment: MainAxisAlignment.start,
                children: [
                  Icon(
                    Icons.family_restroom,
                    color: FlutterFlowTheme.of(context).primaryText,
                    size: 32.0,
                  ),
                  Expanded(
                    child: Column(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        Padding(
                          padding: EdgeInsetsDirectional.fromSTEB(
                              5.0, 0.0, 0.0, 0.0),
                          child: Text(
                            'Parentesco',
                            style: FlutterFlowTheme.of(context)
                                .bodyMedium
                                .override(
                                  fontFamily: 'Montserrat',
                                  fontSize: 12.0,
                                  letterSpacing: 0.0,
                                  fontWeight: FontWeight.bold,
                                ),
                          ),
                        ),
                        Padding(
                          padding: EdgeInsetsDirectional.fromSTEB(
                              5.0, 0.0, 0.0, 0.0),
                          child: Text(
                            valueOrDefault<String>(
                              widget!.parentescoD,
                              'Não definido',
                            ),
                            style: FlutterFlowTheme.of(context)
                                .bodyMedium
                                .override(
                                  fontFamily: 'Montserrat',
                                  color: FlutterFlowTheme.of(context).primary,
                                  fontSize: 12.0,
                                  letterSpacing: 0.0,
                                  fontWeight: FontWeight.bold,
                                ),
                          ),
                        ),
                      ],
                    ),
                  ),
                  Icon(
                    Icons.cake_outlined,
                    color: FlutterFlowTheme.of(context).primaryText,
                    size: 32.0,
                  ),
                  Expanded(
                    child: Column(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        Text(
                          'Nascimento',
                          style:
                              FlutterFlowTheme.of(context).bodyMedium.override(
                                    fontFamily: 'Montserrat',
                                    fontSize: 12.0,
                                    letterSpacing: 0.0,
                                    fontWeight: FontWeight.bold,
                                  ),
                        ),
                        Text(
                          valueOrDefault<String>(
                            widget!.nascimentoD,
                            'Não definido',
                          ),
                          style:
                              FlutterFlowTheme.of(context).bodyMedium.override(
                                    fontFamily: 'Montserrat',
                                    color: FlutterFlowTheme.of(context).primary,
                                    fontSize: 12.0,
                                    letterSpacing: 0.0,
                                    fontWeight: FontWeight.bold,
                                  ),
                        ),
                      ],
                    ),
                  ),
                ],
              ),
            ),
            Padding(
              padding: EdgeInsetsDirectional.fromSTEB(15.0, 0.0, 15.0, 10.0),
              child: Row(
                mainAxisSize: MainAxisSize.max,
                mainAxisAlignment: MainAxisAlignment.start,
                children: [
                  Icon(
                    Icons.calendar_month_outlined,
                    color: FlutterFlowTheme.of(context).primaryText,
                    size: 32.0,
                  ),
                  Expanded(
                    child: Column(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        Padding(
                          padding: EdgeInsetsDirectional.fromSTEB(
                              5.0, 0.0, 0.0, 0.0),
                          child: Text(
                            'Inclusão',
                            style: FlutterFlowTheme.of(context)
                                .bodyMedium
                                .override(
                                  fontFamily: 'Montserrat',
                                  fontSize: 12.0,
                                  letterSpacing: 0.0,
                                  fontWeight: FontWeight.bold,
                                ),
                          ),
                        ),
                        Padding(
                          padding: EdgeInsetsDirectional.fromSTEB(
                              5.0, 0.0, 0.0, 0.0),
                          child: Text(
                            valueOrDefault<String>(
                              widget!.inclusaoD,
                              'Não definido',
                            ),
                            style: FlutterFlowTheme.of(context)
                                .bodyMedium
                                .override(
                                  fontFamily: 'Montserrat',
                                  color: FlutterFlowTheme.of(context).primary,
                                  fontSize: 12.0,
                                  letterSpacing: 0.0,
                                  fontWeight: FontWeight.bold,
                                ),
                          ),
                        ),
                      ],
                    ),
                  ),
                  Icon(
                    Icons.calendar_month_outlined,
                    color: FlutterFlowTheme.of(context).primaryText,
                    size: 32.0,
                  ),
                  Expanded(
                    child: Column(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        Text(
                          'Fim da Carência',
                          style:
                              FlutterFlowTheme.of(context).bodyMedium.override(
                                    fontFamily: 'Montserrat',
                                    fontSize: 12.0,
                                    letterSpacing: 0.0,
                                    fontWeight: FontWeight.bold,
                                  ),
                        ),
                        Text(
                          valueOrDefault<String>(
                            widget!.fimcarenciaD,
                            'Não definido',
                          ),
                          style:
                              FlutterFlowTheme.of(context).bodyMedium.override(
                                    fontFamily: 'Montserrat',
                                    color: FlutterFlowTheme.of(context).error,
                                    fontSize: 12.0,
                                    letterSpacing: 0.0,
                                    fontWeight: FontWeight.bold,
                                  ),
                        ),
                      ],
                    ),
                  ),
                ],
              ),
            ),
          ],
        ),
      ),
    );
  }
}
