import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import 'dart:ui';
import 'package:auto_size_text/auto_size_text.dart';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';
import 'historico_solicitacoes_card_model.dart';
export 'historico_solicitacoes_card_model.dart';

class HistoricoSolicitacoesCardWidget extends StatefulWidget {
  const HistoricoSolicitacoesCardWidget({
    super.key,
    this.statusD,
    this.datahoracriacaoD,
    this.categoriaD,
    this.tipoD,
    this.idsolicitacaoD,
    this.atendenteD,
    this.observacaoD,
    this.nomeatendenteD,
    this.avatarD,
  });

  final String? statusD;
  final String? datahoracriacaoD;
  final String? categoriaD;
  final String? tipoD;
  final int? idsolicitacaoD;
  final int? atendenteD;
  final String? observacaoD;
  final String? nomeatendenteD;
  final String? avatarD;

  @override
  State<HistoricoSolicitacoesCardWidget> createState() =>
      _HistoricoSolicitacoesCardWidgetState();
}

class _HistoricoSolicitacoesCardWidgetState
    extends State<HistoricoSolicitacoesCardWidget> {
  late HistoricoSolicitacoesCardModel _model;

  @override
  void setState(VoidCallback callback) {
    super.setState(callback);
    _model.onUpdate();
  }

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => HistoricoSolicitacoesCardModel());

    WidgetsBinding.instance.addPostFrameCallback((_) => safeSetState(() {}));
  }

  @override
  void dispose() {
    _model.maybeDispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Card(
      clipBehavior: Clip.antiAliasWithSaveLayer,
      color: FlutterFlowTheme.of(context).secondaryBackground,
      elevation: 3.0,
      shape: RoundedRectangleBorder(
        borderRadius: BorderRadius.circular(10.0),
      ),
      child: Container(
        width: double.infinity,
        decoration: BoxDecoration(
          color: Colors.transparent,
          border: Border.all(
            color: Colors.transparent,
          ),
        ),
        child: Column(
          mainAxisSize: MainAxisSize.max,
          children: [
            Align(
              alignment: AlignmentDirectional(0.0, 0.0),
              child: Padding(
                padding: EdgeInsetsDirectional.fromSTEB(15.0, 10.0, 15.0, 15.0),
                child: InkWell(
                  splashColor: Colors.transparent,
                  focusColor: Colors.transparent,
                  hoverColor: Colors.transparent,
                  highlightColor: Colors.transparent,
                  onTap: () async {
                    context.pushNamed(
                      'HistoricoDetalhes',
                      queryParameters: {
                        'tiposolicitacao': serializeParam(
                          widget!.tipoD,
                          ParamType.String,
                        ),
                        'datahorasolicitacao': serializeParam(
                          widget!.datahoracriacaoD,
                          ParamType.String,
                        ),
                        'statussolicitacao': serializeParam(
                          widget!.statusD,
                          ParamType.String,
                        ),
                        'atendentesolicitacao': serializeParam(
                          widget!.atendenteD,
                          ParamType.int,
                        ),
                        'observacaosolicitacao': serializeParam(
                          widget!.observacaoD,
                          ParamType.String,
                        ),
                        'idsolicitacao': serializeParam(
                          widget!.idsolicitacaoD,
                          ParamType.int,
                        ),
                        'nomeatendentesolicitacao': serializeParam(
                          widget!.nomeatendenteD,
                          ParamType.String,
                        ),
                        'avataratendentesolicitacao': serializeParam(
                          widget!.avatarD == null || widget!.avatarD == ''
                              ? 'https://cemiteriojardimeden.com.br/jardim-eden-admin/public/img/avatars/atendente_default.png'
                              : widget!.avatarD,
                          ParamType.String,
                        ),
                      }.withoutNulls,
                    );
                  },
                  child: Row(
                    mainAxisSize: MainAxisSize.max,
                    mainAxisAlignment: MainAxisAlignment.start,
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: [
                      if (widget!.tipoD == '7')
                        ClipRRect(
                          borderRadius: BorderRadius.circular(24.0),
                          child: Image.asset(
                            'assets/images/200px.png',
                            width: 50.0,
                            height: 50.0,
                            fit: BoxFit.cover,
                          ),
                        ),
                      if ((widget!.tipoD == '1') ||
                          (widget!.tipoD == '5') ||
                          (widget!.tipoD == '6'))
                        ClipRRect(
                          borderRadius: BorderRadius.circular(24.0),
                          child: Image.asset(
                            'assets/images/dadoscadastrais.png',
                            width: 50.0,
                            height: 50.0,
                            fit: BoxFit.cover,
                          ),
                        ),
                      if (widget!.tipoD == '2')
                        ClipRRect(
                          borderRadius: BorderRadius.circular(24.0),
                          child: Image.asset(
                            'assets/images/planos.png',
                            width: 50.0,
                            height: 50.0,
                            fit: BoxFit.cover,
                          ),
                        ),
                      if ((widget!.tipoD == '3') ||
                          (widget!.tipoD == '4') ||
                          (widget!.tipoD == '8'))
                        ClipRRect(
                          borderRadius: BorderRadius.circular(24.0),
                          child: Image.asset(
                            'assets/images/dependentes.png',
                            width: 50.0,
                            height: 50.0,
                            fit: BoxFit.cover,
                          ),
                        ),
                      Padding(
                        padding:
                            EdgeInsetsDirectional.fromSTEB(10.0, 0.0, 0.0, 0.0),
                        child: Column(
                          mainAxisSize: MainAxisSize.max,
                          mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: [
                            Align(
                              alignment: AlignmentDirectional(0.0, 0.0),
                              child: AutoSizeText(
                                () {
                                  if (widget!.tipoD == '1') {
                                    return 'Alteração cadastral';
                                  } else if (widget!.tipoD == '2') {
                                    return 'Alteração de plano';
                                  } else if (widget!.tipoD == '3') {
                                    return 'Inclusão de dependente';
                                  } else if (widget!.tipoD == '4') {
                                    return 'Alteração de dependente';
                                  } else if (widget!.tipoD == '5') {
                                    return 'Inclusão de representante';
                                  } else if (widget!.tipoD == '6') {
                                    return 'Alteração de representante';
                                  } else if (widget!.tipoD == '7') {
                                    return 'Ajustar solicitação';
                                  } else if (widget!.tipoD == '8') {
                                    return 'Exclusão de dependente';
                                  } else {
                                    return 'Não definido';
                                  }
                                }(),
                                textAlign: TextAlign.center,
                                style: FlutterFlowTheme.of(context)
                                    .bodyMedium
                                    .override(
                                      fontFamily: 'Montserrat',
                                      fontSize: 16.0,
                                      letterSpacing: 0.0,
                                      fontWeight: FontWeight.bold,
                                    ),
                              ),
                            ),
                            Align(
                              alignment: AlignmentDirectional(0.0, 0.0),
                              child: AutoSizeText(
                                valueOrDefault<String>(
                                  widget!.datahoracriacaoD,
                                  '--/--/---- --:--',
                                ),
                                textAlign: TextAlign.center,
                                style: FlutterFlowTheme.of(context)
                                    .bodyMedium
                                    .override(
                                      fontFamily: 'Montserrat',
                                      fontSize: 14.0,
                                      letterSpacing: 0.0,
                                      fontWeight: FontWeight.w600,
                                    ),
                              ),
                            ),
                            Padding(
                              padding: EdgeInsetsDirectional.fromSTEB(
                                  0.0, 0.0, 0.0, 10.0),
                              child: Row(
                                mainAxisSize: MainAxisSize.max,
                                mainAxisAlignment: MainAxisAlignment.start,
                                crossAxisAlignment: CrossAxisAlignment.center,
                                children: [
                                  Text(
                                    'Status',
                                    style: FlutterFlowTheme.of(context)
                                        .bodyMedium
                                        .override(
                                          fontFamily: 'Montserrat',
                                          fontSize: 16.0,
                                          letterSpacing: 0.0,
                                          fontWeight: FontWeight.w600,
                                        ),
                                  ),
                                  Align(
                                    alignment: AlignmentDirectional(0.0, 0.0),
                                    child: Padding(
                                      padding: EdgeInsetsDirectional.fromSTEB(
                                          10.0, 0.0, 0.0, 0.0),
                                      child: Container(
                                        width: 153.0,
                                        height: 24.0,
                                        decoration: BoxDecoration(
                                          color: () {
                                            if (widget!.statusD == '1') {
                                              return Color(0xFF3B77F9);
                                            } else if (widget!.statusD == '2') {
                                              return Color(0xFFEFAC17);
                                            } else if (widget!.statusD == '3') {
                                              return Color(0xFF61CE70);
                                            } else if (widget!.statusD == '4') {
                                              return Color(0xFF663D3B);
                                            } else if (widget!.statusD == '5') {
                                              return Color(0xFFEA3C31);
                                            } else {
                                              return Color(0xFF7B4848);
                                            }
                                          }(),
                                          borderRadius:
                                              BorderRadius.circular(6.0),
                                          shape: BoxShape.rectangle,
                                        ),
                                        alignment:
                                            AlignmentDirectional(0.0, 0.0),
                                        child: Text(
                                          () {
                                            if (widget!.statusD == '1') {
                                              return 'Solicitada';
                                            } else if (widget!.statusD == '2') {
                                              return 'Em análise';
                                            } else if (widget!.statusD == '3') {
                                              return 'Concluída';
                                            } else if (widget!.statusD == '4') {
                                              return 'Encaminhada';
                                            } else if (widget!.statusD == '5') {
                                              return 'Recusada';
                                            } else {
                                              return 'Indefinido';
                                            }
                                          }(),
                                          style: FlutterFlowTheme.of(context)
                                              .bodyMedium
                                              .override(
                                                fontFamily: 'Inter',
                                                color: widget!.statusD != '0'
                                                    ? FlutterFlowTheme.of(
                                                            context)
                                                        .secondaryBackground
                                                    : FlutterFlowTheme.of(
                                                            context)
                                                        .primaryText,
                                                fontSize: 11.0,
                                                letterSpacing: 0.0,
                                                fontWeight: FontWeight.bold,
                                              ),
                                        ),
                                      ),
                                    ),
                                  ),
                                ],
                              ),
                            ),
                          ].divide(SizedBox(height: 10.0)),
                        ),
                      ),
                    ],
                  ),
                ),
              ),
            ),
          ],
        ),
      ),
    );
  }
}
