import '/backend/api_requests/api_calls.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:mask_text_input_formatter/mask_text_input_formatter.dart';
import 'package:provider/provider.dart';
import 'adicionar_representante_model.dart';
export 'adicionar_representante_model.dart';

class AdicionarRepresentanteWidget extends StatefulWidget {
  const AdicionarRepresentanteWidget({super.key});

  @override
  State<AdicionarRepresentanteWidget> createState() =>
      _AdicionarRepresentanteWidgetState();
}

class _AdicionarRepresentanteWidgetState
    extends State<AdicionarRepresentanteWidget> {
  late AdicionarRepresentanteModel _model;

  final scaffoldKey = GlobalKey<ScaffoldState>();

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => AdicionarRepresentanteModel());

    _model.txtCpfTextController ??= TextEditingController();
    _model.txtCpfFocusNode ??= FocusNode();

    _model.txtDataNascTextController ??= TextEditingController();
    _model.txtDataNascFocusNode ??= FocusNode();

    WidgetsBinding.instance.addPostFrameCallback((_) => safeSetState(() {}));
  }

  @override
  void dispose() {
    _model.dispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    context.watch<FFAppState>();

    return Title(
        title: 'AdicionarRepresentante',
        color: FlutterFlowTheme.of(context).primary.withAlpha(0XFF),
        child: GestureDetector(
          onTap: () {
            FocusScope.of(context).unfocus();
            FocusManager.instance.primaryFocus?.unfocus();
          },
          child: Scaffold(
            key: scaffoldKey,
            backgroundColor: Color(0xFFF7F5F6),
            body: SafeArea(
              top: true,
              child: Column(
                mainAxisSize: MainAxisSize.max,
                children: [
                  Padding(
                    padding:
                        EdgeInsetsDirectional.fromSTEB(0.0, 50.0, 0.0, 0.0),
                    child: Row(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        Container(
                          width: 100.0,
                          height: 100.0,
                          decoration: BoxDecoration(
                            color: Color(0xFF06361E),
                            image: DecorationImage(
                              fit: BoxFit.cover,
                              image: Image.asset(
                                'assets/images/200px2.png',
                              ).image,
                            ),
                            shape: BoxShape.circle,
                          ),
                        ),
                      ],
                    ),
                  ),
                  Padding(
                    padding:
                        EdgeInsetsDirectional.fromSTEB(15.0, 50.0, 15.0, 0.0),
                    child: Row(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        Flexible(
                          child: Text(
                            'Digite o CPF e a \nData de nascimento \ndo titular do contrato',
                            textAlign: TextAlign.center,
                            style: FlutterFlowTheme.of(context)
                                .bodyMedium
                                .override(
                                  fontFamily: 'Montserrat',
                                  fontSize: 20.0,
                                  letterSpacing: 0.0,
                                  fontWeight: FontWeight.normal,
                                ),
                          ),
                        ),
                      ],
                    ),
                  ),
                  Padding(
                    padding:
                        EdgeInsetsDirectional.fromSTEB(0.0, 50.0, 0.0, 0.0),
                    child: Row(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        Container(
                          width: 300.0,
                          child: TextFormField(
                            controller: _model.txtCpfTextController,
                            focusNode: _model.txtCpfFocusNode,
                            autofocus: false,
                            obscureText: false,
                            decoration: InputDecoration(
                              isDense: true,
                              labelText: 'CPF',
                              labelStyle: FlutterFlowTheme.of(context)
                                  .labelMedium
                                  .override(
                                    fontFamily: 'Montserrat',
                                    fontSize: 16.0,
                                    letterSpacing: 0.0,
                                    fontWeight: FontWeight.normal,
                                  ),
                              hintStyle: FlutterFlowTheme.of(context)
                                  .labelMedium
                                  .override(
                                    fontFamily: 'Montserrat',
                                    fontSize: 16.0,
                                    letterSpacing: 0.0,
                                  ),
                              enabledBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                                  color: Color(0xFFB3B3B3),
                                  width: 2.0,
                                ),
                                borderRadius: BorderRadius.circular(8.0),
                              ),
                              focusedBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                                  color: FlutterFlowTheme.of(context).primary,
                                  width: 2.0,
                                ),
                                borderRadius: BorderRadius.circular(8.0),
                              ),
                              errorBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                                  color: FlutterFlowTheme.of(context).error,
                                  width: 2.0,
                                ),
                                borderRadius: BorderRadius.circular(8.0),
                              ),
                              focusedErrorBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                                  color: FlutterFlowTheme.of(context).error,
                                  width: 2.0,
                                ),
                                borderRadius: BorderRadius.circular(8.0),
                              ),
                              filled: true,
                              fillColor: FlutterFlowTheme.of(context)
                                  .secondaryBackground,
                            ),
                            style: FlutterFlowTheme.of(context)
                                .bodyMedium
                                .override(
                                  fontFamily: 'Montserrat',
                                  fontSize: 16.0,
                                  letterSpacing: 0.0,
                                ),
                            keyboardType: TextInputType.number,
                            cursorColor:
                                FlutterFlowTheme.of(context).primaryText,
                            validator: _model.txtCpfTextControllerValidator
                                .asValidator(context),
                            inputFormatters: [_model.txtCpfMask],
                          ),
                        ),
                      ],
                    ),
                  ),
                  Padding(
                    padding:
                        EdgeInsetsDirectional.fromSTEB(0.0, 30.0, 0.0, 0.0),
                    child: Row(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        Container(
                          width: 300.0,
                          child: TextFormField(
                            controller: _model.txtDataNascTextController,
                            focusNode: _model.txtDataNascFocusNode,
                            autofocus: false,
                            obscureText: false,
                            decoration: InputDecoration(
                              isDense: true,
                              labelText: 'Data de Nascimento',
                              labelStyle: FlutterFlowTheme.of(context)
                                  .labelMedium
                                  .override(
                                    fontFamily: 'Montserrat',
                                    fontSize: 16.0,
                                    letterSpacing: 0.0,
                                    fontWeight: FontWeight.normal,
                                  ),
                              hintStyle: FlutterFlowTheme.of(context)
                                  .labelMedium
                                  .override(
                                    fontFamily: 'Montserrat',
                                    fontSize: 16.0,
                                    letterSpacing: 0.0,
                                  ),
                              enabledBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                                  color: Color(0xFFB3B3B3),
                                  width: 2.0,
                                ),
                                borderRadius: BorderRadius.circular(8.0),
                              ),
                              focusedBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                                  color: FlutterFlowTheme.of(context).primary,
                                  width: 2.0,
                                ),
                                borderRadius: BorderRadius.circular(8.0),
                              ),
                              errorBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                                  color: FlutterFlowTheme.of(context).error,
                                  width: 2.0,
                                ),
                                borderRadius: BorderRadius.circular(8.0),
                              ),
                              focusedErrorBorder: OutlineInputBorder(
                                borderSide: BorderSide(
                                  color: FlutterFlowTheme.of(context).error,
                                  width: 2.0,
                                ),
                                borderRadius: BorderRadius.circular(8.0),
                              ),
                              filled: true,
                              fillColor: FlutterFlowTheme.of(context)
                                  .secondaryBackground,
                            ),
                            style: FlutterFlowTheme.of(context)
                                .bodyMedium
                                .override(
                                  fontFamily: 'Montserrat',
                                  fontSize: 16.0,
                                  letterSpacing: 0.0,
                                ),
                            keyboardType: TextInputType.datetime,
                            cursorColor:
                                FlutterFlowTheme.of(context).primaryText,
                            validator: _model.txtDataNascTextControllerValidator
                                .asValidator(context),
                            inputFormatters: [_model.txtDataNascMask],
                          ),
                        ),
                      ],
                    ),
                  ),
                  Padding(
                    padding:
                        EdgeInsetsDirectional.fromSTEB(0.0, 30.0, 0.0, 0.0),
                    child: Row(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        Column(
                          mainAxisSize: MainAxisSize.max,
                          children: [
                            FFButtonWidget(
                              onPressed: () async {
                                if ((_model.txtDataNascTextController.text !=
                                            null &&
                                        _model.txtDataNascTextController.text !=
                                            '') &&
                                    (_model.txtCpfTextController.text != null &&
                                        _model.txtCpfTextController.text !=
                                            '')) {
                                  if (functions.isValidCPF(functions.cpfNoMask(
                                          _model.txtCpfTextController.text)!) ==
                                      true) {
                                    _model.apiResultyzh =
                                        await GrupoAPIAvantinoIGroup
                                            .consultaPlanosBeneficiarioPorCPFEDataNascimentoCall
                                            .call(
                                      cpf: functions.cpfNoMask(
                                          _model.txtCpfTextController.text),
                                      dtNascimento: functions.formatDateToDB(
                                          _model
                                              .txtDataNascTextController.text),
                                      token: FFAppState().avantToken,
                                      dominio: 'cje',
                                    );

                                    if ((_model.apiResultyzh?.succeeded ??
                                        true)) {
                                      if ((_model.apiResultyzh?.bodyText ??
                                              '') !=
                                          '[]') {
                                        _model.apiResult3m5 =
                                            await GrupoAPIAvantinoIGroup
                                                .beneficiariosIDContratoCall
                                                .call(
                                          idCont: GrupoAPIAvantinoIGroup
                                              .consultaPlanosBeneficiarioPorCPFEDataNascimentoCall
                                              .idContrato(
                                                (_model.apiResultyzh
                                                        ?.jsonBody ??
                                                    ''),
                                              )
                                              ?.firstOrNull
                                              ?.toString(),
                                          token: FFAppState().avantToken,
                                          dominio: 'cje',
                                        );

                                        if ((_model.apiResult3m5?.succeeded ??
                                            true)) {
                                          FFAppState().Valor4 = GrupoAPIAvantinoIGroup
                                              .consultaPlanosBeneficiarioPorCPFEDataNascimentoCall
                                              .nmPessoa(
                                                (_model.apiResultyzh
                                                        ?.jsonBody ??
                                                    ''),
                                              )!
                                              .where((e) =>
                                                  functions.cpfNoMask(
                                                      GrupoAPIAvantinoIGroup
                                                          .consultaPlanosBeneficiarioPorCPFEDataNascimentoCall
                                                          .cdCPF(
                                                            (_model.apiResultyzh
                                                                    ?.jsonBody ??
                                                                ''),
                                                          )!
                                                          .firstOrNull!) ==
                                                  functions.cpfNoMask(_model
                                                      .txtCpfTextController
                                                      .text))
                                              .toList()
                                              .cast<String>();
                                          safeSetState(() {});
                                          FFAppState().Valor5 = GrupoAPIAvantinoIGroup
                                              .consultaPlanosBeneficiarioPorCPFEDataNascimentoCall
                                              .idContrato(
                                                (_model.apiResultyzh
                                                        ?.jsonBody ??
                                                    ''),
                                              )!
                                              .where((e) =>
                                                  functions.cpfNoMask(
                                                      GrupoAPIAvantinoIGroup
                                                          .consultaPlanosBeneficiarioPorCPFEDataNascimentoCall
                                                          .cdCPF(
                                                            (_model.apiResultyzh
                                                                    ?.jsonBody ??
                                                                ''),
                                                          )!
                                                          .firstOrNull!) ==
                                                  functions.cpfNoMask(_model
                                                      .txtCpfTextController
                                                      .text))
                                              .toList()
                                              .cast<int>();
                                          safeSetState(() {});
                                          if (FFAppState().Valor4.isNotEmpty) {
                                            await showDialog(
                                              context: context,
                                              builder: (alertDialogContext) {
                                                return AlertDialog(
                                                  content: Text(
                                                      '${FFAppState().Valor4.firstOrNull} - ${FFAppState().Valor5.firstOrNull?.toString()}'),
                                                  actions: [
                                                    TextButton(
                                                      onPressed: () =>
                                                          Navigator.pop(
                                                              alertDialogContext),
                                                      child: Text('Ok'),
                                                    ),
                                                  ],
                                                );
                                              },
                                            );
                                          } else {
                                            await showDialog(
                                              context: context,
                                              builder: (alertDialogContext) {
                                                return AlertDialog(
                                                  content: Text('FALHOU!!'),
                                                  actions: [
                                                    TextButton(
                                                      onPressed: () =>
                                                          Navigator.pop(
                                                              alertDialogContext),
                                                      child: Text('Ok'),
                                                    ),
                                                  ],
                                                );
                                              },
                                            );
                                          }

                                          FFAppState().Valor1 =
                                              FFAppState().userId;
                                          FFAppState().Valor2 =
                                              functions.cpfNoMask(_model
                                                  .txtCpfTextController.text)!;
                                          FFAppState().Valor3 =
                                              functions.formatDateToDB(_model
                                                  .txtDataNascTextController
                                                  .text);
                                          safeSetState(() {});
                                          _model.apiResulty7l =
                                              await ServidorJardimUsuariosGroup
                                                  .addRepresentanteCall
                                                  .call(
                                            usuarioId: FFAppState().userId,
                                            cpf: FFAppState().Valor2,
                                            nome:
                                                FFAppState().Valor4.firstOrNull,
                                            dataNascimento: FFAppState().Valor3,
                                            token: FFAppState().userToken,
                                            parentesco: FFAppState()
                                                .Valor5
                                                .firstOrNull
                                                ?.toString(),
                                          );

                                          if ((_model.apiResulty7l?.succeeded ??
                                              true)) {
                                            await showDialog(
                                              context: context,
                                              builder: (alertDialogContext) {
                                                return AlertDialog(
                                                  content: Text('Sucesso!'),
                                                  actions: [
                                                    TextButton(
                                                      onPressed: () =>
                                                          Navigator.pop(
                                                              alertDialogContext),
                                                      child: Text('Ok'),
                                                    ),
                                                  ],
                                                );
                                              },
                                            );
                                            _model.representantes =
                                                await ServidorJardimUsuariosGroup
                                                    .getRepresentantesCall
                                                    .call(
                                              usuarioId: FFAppState().userId,
                                              token: FFAppState().userToken,
                                            );

                                            if ((_model.representantes
                                                    ?.succeeded ??
                                                true)) {
                                              if (ServidorJardimUsuariosGroup
                                                      .getRepresentantesCall
                                                      .result(
                                                        (_model.representantes
                                                                ?.jsonBody ??
                                                            ''),
                                                      )!
                                                      .length >
                                                  0) {
                                                context.goNamed(
                                                  'SelecionarUsuario',
                                                  queryParameters: {
                                                    'representantes':
                                                        serializeParam(
                                                      ServidorJardimUsuariosGroup
                                                          .getRepresentantesCall
                                                          .result(
                                                        (_model.representantes
                                                                ?.jsonBody ??
                                                            ''),
                                                      ),
                                                      ParamType.DataStruct,
                                                      isList: true,
                                                    ),
                                                  }.withoutNulls,
                                                );
                                              } else {
                                                context.goNamed(
                                                    'AdicionarRepresentante');
                                              }
                                            } else {
                                              await showDialog(
                                                context: context,
                                                builder: (alertDialogContext) {
                                                  return AlertDialog(
                                                    title: Text('Atenção!'),
                                                    content: Text(
                                                        'Não foi possível obter os dados, tente mais tarde!'),
                                                    actions: [
                                                      TextButton(
                                                        onPressed: () =>
                                                            Navigator.pop(
                                                                alertDialogContext),
                                                        child: Text('Ok'),
                                                      ),
                                                    ],
                                                  );
                                                },
                                              );
                                            }
                                          } else {
                                            if ((_model.apiResulty7l
                                                        ?.bodyText ??
                                                    '') ==
                                                '{\"detail\":\"CPF jÃ¡ registrado para outro usuÃ¡rio\"}') {
                                              await showDialog(
                                                context: context,
                                                builder: (alertDialogContext) {
                                                  return AlertDialog(
                                                    content: Text(
                                                        'O CPF informado já está cadastrado! Tente outro CPF.'),
                                                    actions: [
                                                      TextButton(
                                                        onPressed: () =>
                                                            Navigator.pop(
                                                                alertDialogContext),
                                                        child: Text('Ok'),
                                                      ),
                                                    ],
                                                  );
                                                },
                                              );
                                            } else {
                                              await showDialog(
                                                context: context,
                                                builder: (alertDialogContext) {
                                                  return AlertDialog(
                                                    content: Text(
                                                        'Falha durante a tentativa de cadastro! Tente novamente mais tarde.'),
                                                    actions: [
                                                      TextButton(
                                                        onPressed: () =>
                                                            Navigator.pop(
                                                                alertDialogContext),
                                                        child: Text('Ok'),
                                                      ),
                                                    ],
                                                  );
                                                },
                                              );
                                            }
                                          }
                                        } else {
                                          await showDialog(
                                            context: context,
                                            builder: (alertDialogContext) {
                                              return AlertDialog(
                                                content: Text(
                                                    'Beneficiários não encontrados!'),
                                                actions: [
                                                  TextButton(
                                                    onPressed: () =>
                                                        Navigator.pop(
                                                            alertDialogContext),
                                                    child: Text('Ok'),
                                                  ),
                                                ],
                                              );
                                            },
                                          );
                                        }
                                      } else {
                                        await showDialog(
                                          context: context,
                                          builder: (alertDialogContext) {
                                            return AlertDialog(
                                              content: Text(
                                                  'Dados não encontrados!'),
                                              actions: [
                                                TextButton(
                                                  onPressed: () =>
                                                      Navigator.pop(
                                                          alertDialogContext),
                                                  child: Text('Ok'),
                                                ),
                                              ],
                                            );
                                          },
                                        );
                                      }
                                    } else {
                                      await showDialog(
                                        context: context,
                                        builder: (alertDialogContext) {
                                          return AlertDialog(
                                            content: Text(
                                                'Falha durante a consulta dos ddos! Tente novamente mais tarde.'),
                                            actions: [
                                              TextButton(
                                                onPressed: () => Navigator.pop(
                                                    alertDialogContext),
                                                child: Text('Ok'),
                                              ),
                                            ],
                                          );
                                        },
                                      );
                                    }
                                  } else {
                                    await showDialog(
                                      context: context,
                                      builder: (alertDialogContext) {
                                        return AlertDialog(
                                          content: Text('CPF inválido!'),
                                          actions: [
                                            TextButton(
                                              onPressed: () => Navigator.pop(
                                                  alertDialogContext),
                                              child: Text('Ok'),
                                            ),
                                          ],
                                        );
                                      },
                                    );
                                  }
                                } else {
                                  await showDialog(
                                    context: context,
                                    builder: (alertDialogContext) {
                                      return AlertDialog(
                                        content:
                                            Text('Preencha todos os campos!'),
                                        actions: [
                                          TextButton(
                                            onPressed: () => Navigator.pop(
                                                alertDialogContext),
                                            child: Text('Ok'),
                                          ),
                                        ],
                                      );
                                    },
                                  );
                                }

                                safeSetState(() {});
                              },
                              text: 'Procurar',
                              options: FFButtonOptions(
                                width: 150.0,
                                height: 40.0,
                                padding: EdgeInsetsDirectional.fromSTEB(
                                    16.0, 0.0, 16.0, 0.0),
                                iconPadding: EdgeInsetsDirectional.fromSTEB(
                                    0.0, 0.0, 0.0, 0.0),
                                color: Color(0xFF28AADF),
                                textStyle: FlutterFlowTheme.of(context)
                                    .titleSmall
                                    .override(
                                      fontFamily: 'Montserrat',
                                      color: Colors.white,
                                      letterSpacing: 0.0,
                                    ),
                                elevation: 0.0,
                                borderRadius: BorderRadius.circular(5.0),
                              ),
                            ),
                            Padding(
                              padding: EdgeInsetsDirectional.fromSTEB(
                                  0.0, 15.0, 0.0, 0.0),
                              child: FFButtonWidget(
                                onPressed: () async {
                                  context.safePop();
                                },
                                text: 'Voltar',
                                options: FFButtonOptions(
                                  width: 150.0,
                                  height: 40.0,
                                  padding: EdgeInsetsDirectional.fromSTEB(
                                      16.0, 0.0, 16.0, 0.0),
                                  iconPadding: EdgeInsetsDirectional.fromSTEB(
                                      0.0, 0.0, 0.0, 0.0),
                                  color: Color(0xFF28AADF),
                                  textStyle: FlutterFlowTheme.of(context)
                                      .titleSmall
                                      .override(
                                        fontFamily: 'Montserrat',
                                        color: Colors.white,
                                        letterSpacing: 0.0,
                                      ),
                                  elevation: 0.0,
                                  borderRadius: BorderRadius.circular(5.0),
                                ),
                              ),
                            ),
                          ],
                        ),
                      ],
                    ),
                  ),
                ],
              ),
            ),
          ),
        ));
  }
}
