import '/backend/api_requests/api_calls.dart';
import '/components/aviso1_widget.dart';
import '/components/aviso2_widget.dart';
import '/components/loading_widget.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/custom_code/actions/index.dart' as actions;
import '/flutter_flow/custom_functions.dart' as functions;
import 'dados_pessoais_widget.dart' show DadosPessoaisWidget;
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:mask_text_input_formatter/mask_text_input_formatter.dart';
import 'package:provider/provider.dart';

class DadosPessoaisModel extends FlutterFlowModel<DadosPessoaisWidget> {
  ///  Local state fields for this page.

  List<FFUploadedFile> filesPDF = [];
  void addToFilesPDF(FFUploadedFile item) => filesPDF.add(item);
  void removeFromFilesPDF(FFUploadedFile item) => filesPDF.remove(item);
  void removeAtIndexFromFilesPDF(int index) => filesPDF.removeAt(index);
  void insertAtIndexInFilesPDF(int index, FFUploadedFile item) =>
      filesPDF.insert(index, item);
  void updateFilesPDFAtIndex(int index, Function(FFUploadedFile) updateFn) =>
      filesPDF[index] = updateFn(filesPDF[index]);

  ///  State fields for stateful widgets in this page.

  // Stores action output result for [Backend Call - API (Contrato ID Completo Beneficiario)] action in DadosPessoais widget.
  ApiCallResponse? apiResult9u5;
  // Stores action output result for [Backend Call - API (Contrato ID Completo Beneficiario Resumido)] action in DadosPessoais widget.
  ApiCallResponse? apiResultbek;
  // State field(s) for txtContatoPrincipal widget.
  FocusNode? txtContatoPrincipalFocusNode;
  TextEditingController? txtContatoPrincipalTextController;
  final txtContatoPrincipalMask =
      MaskTextInputFormatter(mask: '(##) #####-####');
  String? Function(BuildContext, String?)?
      txtContatoPrincipalTextControllerValidator;
  // State field(s) for txtOutroContato widget.
  FocusNode? txtOutroContatoFocusNode;
  TextEditingController? txtOutroContatoTextController;
  final txtOutroContatoMask = MaskTextInputFormatter(mask: '(##) #####-####');
  String? Function(BuildContext, String?)?
      txtOutroContatoTextControllerValidator;
  // State field(s) for txtCEP widget.
  FocusNode? txtCEPFocusNode;
  TextEditingController? txtCEPTextController;
  final txtCEPMask = MaskTextInputFormatter(mask: '#####-###');
  String? Function(BuildContext, String?)? txtCEPTextControllerValidator;
  // State field(s) for txtLogradouro widget.
  FocusNode? txtLogradouroFocusNode;
  TextEditingController? txtLogradouroTextController;
  String? Function(BuildContext, String?)? txtLogradouroTextControllerValidator;
  // State field(s) for txtNumero widget.
  FocusNode? txtNumeroFocusNode;
  TextEditingController? txtNumeroTextController;
  String? Function(BuildContext, String?)? txtNumeroTextControllerValidator;
  // State field(s) for txtQuadra widget.
  FocusNode? txtQuadraFocusNode;
  TextEditingController? txtQuadraTextController;
  String? Function(BuildContext, String?)? txtQuadraTextControllerValidator;
  // State field(s) for txtLote widget.
  FocusNode? txtLoteFocusNode;
  TextEditingController? txtLoteTextController;
  String? Function(BuildContext, String?)? txtLoteTextControllerValidator;
  // State field(s) for txtBairro widget.
  FocusNode? txtBairroFocusNode;
  TextEditingController? txtBairroTextController;
  String? Function(BuildContext, String?)? txtBairroTextControllerValidator;
  // State field(s) for txtCidadeEstado widget.
  FocusNode? txtCidadeEstadoFocusNode;
  TextEditingController? txtCidadeEstadoTextController;
  String? Function(BuildContext, String?)?
      txtCidadeEstadoTextControllerValidator;
  // State field(s) for txtPontoReferencia widget.
  FocusNode? txtPontoReferenciaFocusNode;
  TextEditingController? txtPontoReferenciaTextController;
  String? Function(BuildContext, String?)?
      txtPontoReferenciaTextControllerValidator;
  // Stores action output result for [Custom Action - documentPicker] action in Button widget.
  List<FFUploadedFile>? fileData;
  // State field(s) for Checkbox widget.
  bool? checkboxValue;
  // Stores action output result for [Backend Call - API (SolicitacaoAlteraRepresentante)] action in ButtonConfirmar widget.
  ApiCallResponse? apiResultaxc;

  @override
  void initState(BuildContext context) {}

  @override
  void dispose() {
    txtContatoPrincipalFocusNode?.dispose();
    txtContatoPrincipalTextController?.dispose();

    txtOutroContatoFocusNode?.dispose();
    txtOutroContatoTextController?.dispose();

    txtCEPFocusNode?.dispose();
    txtCEPTextController?.dispose();

    txtLogradouroFocusNode?.dispose();
    txtLogradouroTextController?.dispose();

    txtNumeroFocusNode?.dispose();
    txtNumeroTextController?.dispose();

    txtQuadraFocusNode?.dispose();
    txtQuadraTextController?.dispose();

    txtLoteFocusNode?.dispose();
    txtLoteTextController?.dispose();

    txtBairroFocusNode?.dispose();
    txtBairroTextController?.dispose();

    txtCidadeEstadoFocusNode?.dispose();
    txtCidadeEstadoTextController?.dispose();

    txtPontoReferenciaFocusNode?.dispose();
    txtPontoReferenciaTextController?.dispose();
  }
}
