import '/backend/api_requests/api_calls.dart';
import '/backend/schema/structs/index.dart';
import '/components/dependentes_card_widget.dart';
import '/flutter_flow/flutter_flow_icon_button.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';
import 'dependentes_model.dart';
export 'dependentes_model.dart';

class DependentesWidget extends StatefulWidget {
  const DependentesWidget({
    super.key,
    this.solicitacaoid,
    this.tipoid,
  });

  final int? solicitacaoid;
  final int? tipoid;

  @override
  State<DependentesWidget> createState() => _DependentesWidgetState();
}

class _DependentesWidgetState extends State<DependentesWidget> {
  late DependentesModel _model;

  final scaffoldKey = GlobalKey<ScaffoldState>();

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => DependentesModel());

    WidgetsBinding.instance.addPostFrameCallback((_) => safeSetState(() {}));
  }

  @override
  void dispose() {
    _model.dispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    context.watch<FFAppState>();

    return Title(
        title: 'Dependentes',
        color: FlutterFlowTheme.of(context).primary.withAlpha(0XFF),
        child: GestureDetector(
          onTap: () {
            FocusScope.of(context).unfocus();
            FocusManager.instance.primaryFocus?.unfocus();
          },
          child: Scaffold(
            key: scaffoldKey,
            backgroundColor: Color(0xFFF7F5F6),
            body: SafeArea(
              top: true,
              child: Column(
                mainAxisSize: MainAxisSize.max,
                mainAxisAlignment: MainAxisAlignment.center,
                children: [
                  Text(
                    'Dependentes',
                    style: FlutterFlowTheme.of(context).bodyMedium.override(
                          fontFamily: 'Inter',
                          fontSize: 24.0,
                          letterSpacing: 0.0,
                          fontWeight: FontWeight.w800,
                        ),
                  ),
                  Padding(
                    padding:
                        EdgeInsetsDirectional.fromSTEB(0.0, 10.0, 0.0, 5.0),
                    child: FlutterFlowIconButton(
                      borderRadius: 18.0,
                      buttonSize: 40.0,
                      fillColor: FlutterFlowTheme.of(context).secondaryText,
                      icon: Icon(
                        Icons.add,
                        color: FlutterFlowTheme.of(context).info,
                        size: 24.0,
                      ),
                      onPressed: () async {
                        if ((widget!.tipoid == 3) ||
                            (widget!.tipoid == 4) ||
                            (widget!.tipoid == 8)) {
                          context.pushNamed(
                            'IncluirDependenteSolicitacao',
                            queryParameters: {
                              'nomecompleto': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'grauparentescoeditar': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'datanascimentoeditar': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'cpfeditar': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'ideditar': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'solicitacaoid': serializeParam(
                                widget!.solicitacaoid,
                                ParamType.int,
                              ),
                            }.withoutNulls,
                          );
                        } else {
                          context.pushNamed(
                            'IncluirDependente',
                            queryParameters: {
                              'nomecompleto': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'grauparentescoeditar': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'datanascimentoeditar': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'cpfeditar': serializeParam(
                                '',
                                ParamType.String,
                              ),
                              'ideditar': serializeParam(
                                '',
                                ParamType.String,
                              ),
                            }.withoutNulls,
                          );
                        }
                      },
                    ),
                  ),
                  SafeArea(
                    child: ClipRRect(
                      child: Container(
                        width: double.infinity,
                        height: 690.0,
                        decoration: BoxDecoration(
                          color: Color(0xFFF7F5F6),
                        ),
                        alignment: AlignmentDirectional(0.0, 0.0),
                        child: Column(
                          mainAxisSize: MainAxisSize.max,
                          mainAxisAlignment: MainAxisAlignment.start,
                          children: [
                            Expanded(
                              child: FutureBuilder<ApiCallResponse>(
                                future: GrupoAPIAvantinoIGroup
                                    .beneficiariosIDContratoCall
                                    .call(
                                  idCont: FFAppState().idselecionado,
                                  token: FFAppState().avantToken,
                                  dominio: 'cje',
                                ),
                                builder: (context, snapshot) {
                                  // Customize what your widget looks like when it's loading.
                                  if (!snapshot.hasData) {
                                    return Center(
                                      child: SizedBox(
                                        width: 50.0,
                                        height: 50.0,
                                        child: CircularProgressIndicator(
                                          valueColor:
                                              AlwaysStoppedAnimation<Color>(
                                            FlutterFlowTheme.of(context)
                                                .primary,
                                          ),
                                        ),
                                      ),
                                    );
                                  }
                                  final listViewBeneficiariosIDContratoResponse =
                                      snapshot.data!;

                                  return Builder(
                                    builder: (context) {
                                      final depententeslista =
                                          (listViewBeneficiariosIDContratoResponse
                                                          .jsonBody
                                                          .toList()
                                                          .map<DependentesDatatypeStruct?>(
                                                              DependentesDatatypeStruct
                                                                  .maybeFromMap)
                                                          .toList()
                                                      as Iterable<
                                                          DependentesDatatypeStruct?>)
                                                  .withoutNulls
                                                  ?.toList() ??
                                              [];

                                      return InkWell(
                                        splashColor: Colors.transparent,
                                        focusColor: Colors.transparent,
                                        hoverColor: Colors.transparent,
                                        highlightColor: Colors.transparent,
                                        onTap: () async {
                                          if (!(depententeslista.isNotEmpty)) {
                                            await showDialog(
                                              context: context,
                                              builder: (alertDialogContext) {
                                                return AlertDialog(
                                                  content: Text(
                                                      'Dependentes não encontrados.'),
                                                  actions: [
                                                    TextButton(
                                                      onPressed: () =>
                                                          Navigator.pop(
                                                              alertDialogContext),
                                                      child: Text('Ok'),
                                                    ),
                                                  ],
                                                );
                                              },
                                            );
                                            context.safePop();
                                          }
                                        },
                                        child: ListView.builder(
                                          padding: EdgeInsets.zero,
                                          primary: false,
                                          shrinkWrap: true,
                                          scrollDirection: Axis.vertical,
                                          itemCount: depententeslista.length,
                                          itemBuilder:
                                              (context, depententeslistaIndex) {
                                            final depententeslistaItem =
                                                depententeslista[
                                                    depententeslistaIndex];
                                            return wrapWithModel(
                                              model: _model
                                                  .dependentesCardModels
                                                  .getModel(
                                                depententeslistaIndex
                                                    .toString(),
                                                depententeslistaIndex,
                                              ),
                                              updateCallback: () =>
                                                  safeSetState(() {}),
                                              child: DependentesCardWidget(
                                                key: Key(
                                                  'Keyjur_${depententeslistaIndex.toString()}',
                                                ),
                                                nomepessoaD:
                                                    depententeslistaItem
                                                        .nmPessoa,
                                                vinculoD: depententeslistaItem
                                                    .nmVinculo,
                                                parentescoD:
                                                    depententeslistaItem.nmGrau,
                                                inclusaoD: functions
                                                    .formatDateTimeToDate(
                                                        depententeslistaItem
                                                            .dtInclusao),
                                                nascimentoD: functions
                                                    .formatDateTimeToDate(
                                                        depententeslistaItem
                                                            .dtNascimento),
                                                fimcarenciaD: functions
                                                    .formatDateTimeToDate(
                                                        depententeslistaItem
                                                            .dtCarencia),
                                                cpfD: functions.cpfNoMask(
                                                    depententeslistaItem
                                                        .cdCPF)!,
                                                iddependenteD:
                                                    depententeslistaItem
                                                        .idPessoa,
                                                solicitacaoidD:
                                                    widget!.solicitacaoid,
                                                tipoidD: widget!.tipoid,
                                              ),
                                            );
                                          },
                                        ),
                                      );
                                    },
                                  );
                                },
                              ),
                            ),
                          ],
                        ),
                      ),
                    ),
                  ),
                ],
              ),
            ),
          ),
        ));
  }
}
