import '/backend/api_requests/api_calls.dart';
import '/backend/schema/structs/index.dart';
import '/components/historico_solicitacoes_card_widget.dart';
import '/flutter_flow/flutter_flow_drop_down.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import '/flutter_flow/form_field_controller.dart';
import 'dart:ui';
import '/flutter_flow/custom_functions.dart' as functions;
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';
import 'historico_solicitacoes_model.dart';
export 'historico_solicitacoes_model.dart';

class HistoricoSolicitacoesWidget extends StatefulWidget {
  const HistoricoSolicitacoesWidget({super.key});

  @override
  State<HistoricoSolicitacoesWidget> createState() =>
      _HistoricoSolicitacoesWidgetState();
}

class _HistoricoSolicitacoesWidgetState
    extends State<HistoricoSolicitacoesWidget> {
  late HistoricoSolicitacoesModel _model;

  final scaffoldKey = GlobalKey<ScaffoldState>();

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => HistoricoSolicitacoesModel());

    // On page load action.
    SchedulerBinding.instance.addPostFrameCallback((_) async {
      FFAppState().filtroOnOff = false;
      FFAppState().statusselecionado = 0;
      FFAppState().tiposelecionado = 0;
      safeSetState(() {});
    });

    WidgetsBinding.instance.addPostFrameCallback((_) => safeSetState(() {}));
  }

  @override
  void dispose() {
    _model.dispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    context.watch<FFAppState>();

    return Title(
        title: 'HistoricoSolicitacoes',
        color: FlutterFlowTheme.of(context).primary.withAlpha(0XFF),
        child: GestureDetector(
          onTap: () {
            FocusScope.of(context).unfocus();
            FocusManager.instance.primaryFocus?.unfocus();
          },
          child: Scaffold(
            key: scaffoldKey,
            backgroundColor: Color(0xFFF7F5F6),
            body: SafeArea(
              top: true,
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: [
                  Text(
                    'Histórico de Solicitações',
                    style: FlutterFlowTheme.of(context).bodyMedium.override(
                          fontFamily: 'Inter',
                          fontSize: 24.0,
                          letterSpacing: 0.0,
                          fontWeight: FontWeight.w800,
                        ),
                  ),
                  Padding(
                    padding:
                        EdgeInsetsDirectional.fromSTEB(5.0, 15.0, 5.0, 0.0),
                    child: Row(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        Expanded(
                          child: Column(
                            mainAxisSize: MainAxisSize.max,
                            mainAxisAlignment: MainAxisAlignment.center,
                            children: [
                              FFButtonWidget(
                                onPressed: () async {
                                  if (FFAppState().filtroOnOff == false) {
                                    FFAppState().filtroOnOff = true;
                                    safeSetState(() {});
                                  } else {
                                    FFAppState().filtroOnOff = false;
                                    safeSetState(() {});
                                  }
                                },
                                text: 'Filtrar',
                                icon: Icon(
                                  Icons.tune_rounded,
                                  color: FlutterFlowTheme.of(context)
                                      .primaryBackground,
                                  size: 20.0,
                                ),
                                options: FFButtonOptions(
                                  width: 120.0,
                                  height: 35.0,
                                  padding: EdgeInsetsDirectional.fromSTEB(
                                      0.0, 0.0, 0.0, 0.0),
                                  iconPadding: EdgeInsetsDirectional.fromSTEB(
                                      0.0, 0.0, 0.0, 0.0),
                                  color: Color(0xFFEFAC17),
                                  textStyle: FlutterFlowTheme.of(context)
                                      .titleSmall
                                      .override(
                                        fontFamily: 'Montserrat',
                                        color: FlutterFlowTheme.of(context)
                                            .primaryBackground,
                                        letterSpacing: 0.0,
                                        fontWeight: FontWeight.bold,
                                      ),
                                  elevation: 0.0,
                                  borderRadius: BorderRadius.circular(10.0),
                                ),
                              ),
                              if (FFAppState().filtroOnOff == true)
                                Padding(
                                  padding: EdgeInsetsDirectional.fromSTEB(
                                      0.0, 5.0, 0.0, 0.0),
                                  child: FlutterFlowDropDown<String>(
                                    controller:
                                        _model.dropDownTipoValueController ??=
                                            FormFieldController<String>(null),
                                    options: [
                                      'Alteração cadastral',
                                      'Alteração de plano',
                                      'Inclusão de dependente',
                                      'Alteração de dependente',
                                      'Inclusão de representante',
                                      'Alteração de representante',
                                      'Ajustar solicitação',
                                      'Exclusão de dependente'
                                    ],
                                    onChanged: (val) async {
                                      safeSetState(
                                          () => _model.dropDownTipoValue = val);
                                      if (_model.dropDownTipoValue ==
                                          'Alteração cadastral') {
                                        FFAppState().tiposelecionado = 1;
                                        safeSetState(() {});
                                      } else {
                                        if (_model.dropDownTipoValue ==
                                            'Alteração de plano') {
                                          FFAppState().tiposelecionado = 2;
                                          safeSetState(() {});
                                        } else {
                                          if (_model.dropDownTipoValue ==
                                              'Inclusão de dependente') {
                                            FFAppState().tiposelecionado = 3;
                                            safeSetState(() {});
                                          } else {
                                            if (_model.dropDownTipoValue ==
                                                'Alteração de dependente') {
                                              FFAppState().tiposelecionado = 4;
                                              safeSetState(() {});
                                            } else {
                                              if (_model.dropDownTipoValue ==
                                                  'Inclusão de representante') {
                                                FFAppState().tiposelecionado =
                                                    5;
                                                safeSetState(() {});
                                              } else {
                                                if (_model.dropDownTipoValue ==
                                                    'Alteração de representante') {
                                                  FFAppState().tiposelecionado =
                                                      6;
                                                  safeSetState(() {});
                                                } else {
                                                  if (_model
                                                          .dropDownTipoValue ==
                                                      'Ajustar solicitação') {
                                                    FFAppState()
                                                        .tiposelecionado = 7;
                                                    safeSetState(() {});
                                                  } else {
                                                    if (_model
                                                            .dropDownTipoValue ==
                                                        'Exclusão de dependente') {
                                                      FFAppState()
                                                          .tiposelecionado = 8;
                                                      safeSetState(() {});
                                                    } else {
                                                      FFAppState()
                                                          .tiposelecionado = 0;
                                                      safeSetState(() {});
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    },
                                    width: 327.0,
                                    height: 40.0,
                                    textStyle: FlutterFlowTheme.of(context)
                                        .bodyMedium
                                        .override(
                                          fontFamily: 'Montserrat',
                                          letterSpacing: 0.0,
                                        ),
                                    hintText: 'Selecione o Tipo',
                                    icon: Icon(
                                      Icons.keyboard_arrow_down_rounded,
                                      color: FlutterFlowTheme.of(context)
                                          .secondaryText,
                                      size: 24.0,
                                    ),
                                    fillColor: FlutterFlowTheme.of(context)
                                        .secondaryBackground,
                                    elevation: 2.0,
                                    borderColor: Colors.transparent,
                                    borderWidth: 0.0,
                                    borderRadius: 8.0,
                                    margin: EdgeInsetsDirectional.fromSTEB(
                                        12.0, 0.0, 12.0, 0.0),
                                    hidesUnderline: true,
                                    isOverButton: false,
                                    isSearchable: false,
                                    isMultiSelect: false,
                                  ),
                                ),
                              if (FFAppState().filtroOnOff == true)
                                Padding(
                                  padding: EdgeInsetsDirectional.fromSTEB(
                                      0.0, 5.0, 0.0, 0.0),
                                  child: FlutterFlowDropDown<String>(
                                    controller:
                                        _model.dropDownStatusValueController ??=
                                            FormFieldController<String>(null),
                                    options: [
                                      'Solicitada',
                                      'Em análise',
                                      'Concluída',
                                      'Encaminhada',
                                      'Recusada'
                                    ],
                                    onChanged: (val) async {
                                      safeSetState(() =>
                                          _model.dropDownStatusValue = val);
                                      if (_model.dropDownStatusValue ==
                                          'Solicitada') {
                                        FFAppState().statusselecionado = 1;
                                        safeSetState(() {});
                                      } else {
                                        if (_model.dropDownStatusValue ==
                                            'Em análise') {
                                          FFAppState().statusselecionado = 2;
                                          safeSetState(() {});
                                        } else {
                                          if (_model.dropDownStatusValue ==
                                              'Concluída') {
                                            FFAppState().statusselecionado = 3;
                                            safeSetState(() {});
                                          } else {
                                            if (_model.dropDownStatusValue ==
                                                'Encaminhada') {
                                              FFAppState().statusselecionado =
                                                  4;
                                              safeSetState(() {});
                                            } else {
                                              if (_model.dropDownStatusValue ==
                                                  'Recusada') {
                                                FFAppState().statusselecionado =
                                                    5;
                                                safeSetState(() {});
                                              } else {
                                                FFAppState().statusselecionado =
                                                    0;
                                                safeSetState(() {});
                                              }
                                            }
                                          }
                                        }
                                      }
                                    },
                                    width: 327.0,
                                    height: 40.0,
                                    textStyle: FlutterFlowTheme.of(context)
                                        .bodyMedium
                                        .override(
                                          fontFamily: 'Montserrat',
                                          letterSpacing: 0.0,
                                        ),
                                    hintText: 'Selecione o Status',
                                    icon: Icon(
                                      Icons.keyboard_arrow_down_rounded,
                                      color: FlutterFlowTheme.of(context)
                                          .secondaryText,
                                      size: 24.0,
                                    ),
                                    fillColor: FlutterFlowTheme.of(context)
                                        .secondaryBackground,
                                    elevation: 2.0,
                                    borderColor: Colors.transparent,
                                    borderWidth: 0.0,
                                    borderRadius: 8.0,
                                    margin: EdgeInsetsDirectional.fromSTEB(
                                        12.0, 0.0, 12.0, 0.0),
                                    hidesUnderline: true,
                                    isOverButton: false,
                                    isSearchable: false,
                                    isMultiSelect: false,
                                  ),
                                ),
                            ],
                          ),
                        ),
                      ],
                    ),
                  ),
                  Expanded(
                    child: Padding(
                      padding:
                          EdgeInsetsDirectional.fromSTEB(0.0, 20.0, 0.0, 0.0),
                      child: Container(
                        width: double.infinity,
                        decoration: BoxDecoration(
                          color: Color(0xFFF7F5F6),
                        ),
                        child: Padding(
                          padding: EdgeInsetsDirectional.fromSTEB(
                              5.0, 0.0, 5.0, 0.0),
                          child: FutureBuilder<ApiCallResponse>(
                            future: ServidorJardimUsuariosGroup
                                .solicitacaoHistoricoIDCall
                                .call(
                              id: FFAppState().userId.toString(),
                              token: FFAppState().userToken,
                            ),
                            builder: (context, snapshot) {
                              // Customize what your widget looks like when it's loading.
                              if (!snapshot.hasData) {
                                return Center(
                                  child: SizedBox(
                                    width: 50.0,
                                    height: 50.0,
                                    child: CircularProgressIndicator(
                                      valueColor: AlwaysStoppedAnimation<Color>(
                                        FlutterFlowTheme.of(context).primary,
                                      ),
                                    ),
                                  ),
                                );
                              }
                              final listViewSolicitacaoHistoricoIDResponse =
                                  snapshot.data!;

                              return Builder(
                                builder: (context) {
                                  final historicolista =
                                      (listViewSolicitacaoHistoricoIDResponse
                                                      .jsonBody
                                                      .toList()
                                                      .map<HistoricoDataTypeStruct?>(
                                                          HistoricoDataTypeStruct
                                                              .maybeFromMap)
                                                      .toList()
                                                  as Iterable<
                                                      HistoricoDataTypeStruct?>)
                                              .withoutNulls
                                              ?.where((e) =>
                                                  (e.statusId ==
                                                      FFAppState()
                                                          .statusselecionado) &&
                                                  (e.tipoId ==
                                                      FFAppState()
                                                          .tiposelecionado))
                                              .toList()
                                              ?.toList() ??
                                          [];

                                  return ListView.separated(
                                    padding: EdgeInsets.zero,
                                    primary: false,
                                    shrinkWrap: true,
                                    scrollDirection: Axis.vertical,
                                    itemCount: historicolista.length,
                                    separatorBuilder: (_, __) =>
                                        SizedBox(height: 5.0),
                                    itemBuilder:
                                        (context, historicolistaIndex) {
                                      final historicolistaItem =
                                          historicolista[historicolistaIndex];
                                      return wrapWithModel(
                                        model: _model
                                            .historicoSolicitacoesCardModels
                                            .getModel(
                                          historicolistaIndex.toString(),
                                          historicolistaIndex,
                                        ),
                                        updateCallback: () =>
                                            safeSetState(() {}),
                                        child: HistoricoSolicitacoesCardWidget(
                                          key: Key(
                                            'Key64t_${historicolistaIndex.toString()}',
                                          ),
                                          statusD: historicolistaItem.statusId
                                              .toString(),
                                          datahoracriacaoD: functions
                                              .formatDateTimeToDateTime(
                                                  historicolistaItem
                                                      .dataHoraCriacao),
                                          categoriaD:
                                              historicolistaItem.categoria,
                                          tipoD: historicolistaItem.tipoId
                                              .toString(),
                                          idsolicitacaoD: historicolistaItem.id,
                                          atendenteD:
                                              historicolistaItem.responsavelId,
                                          observacaoD:
                                              historicolistaItem.observacao,
                                          nomeatendenteD: historicolistaItem
                                              .responsavel.name,
                                          avatarD: historicolistaItem
                                              .responsavel.avatar,
                                        ),
                                      );
                                    },
                                  );
                                },
                              );
                            },
                          ),
                        ),
                      ),
                    ),
                  ),
                ],
              ),
            ),
          ),
        ));
  }
}
