import '/backend/api_requests/api_calls.dart';
import '/components/aviso2_widget.dart';
import '/components/aviso5_widget.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import '/custom_code/actions/index.dart' as actions;
import '/flutter_flow/custom_functions.dart' as functions;
import 'incluir_dependente_widget.dart' show IncluirDependenteWidget;
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:mask_text_input_formatter/mask_text_input_formatter.dart';
import 'package:provider/provider.dart';

class IncluirDependenteModel extends FlutterFlowModel<IncluirDependenteWidget> {
  ///  Local state fields for this page.

  List<FFUploadedFile> filesPDF = [];
  void addToFilesPDF(FFUploadedFile item) => filesPDF.add(item);
  void removeFromFilesPDF(FFUploadedFile item) => filesPDF.remove(item);
  void removeAtIndexFromFilesPDF(int index) => filesPDF.removeAt(index);
  void insertAtIndexInFilesPDF(int index, FFUploadedFile item) =>
      filesPDF.insert(index, item);
  void updateFilesPDFAtIndex(int index, Function(FFUploadedFile) updateFn) =>
      filesPDF[index] = updateFn(filesPDF[index]);

  ///  State fields for stateful widgets in this page.

  // State field(s) for txtNomeCompleto widget.
  FocusNode? txtNomeCompletoFocusNode;
  TextEditingController? txtNomeCompletoTextController;
  String? Function(BuildContext, String?)?
      txtNomeCompletoTextControllerValidator;
  // State field(s) for txtCpf widget.
  FocusNode? txtCpfFocusNode;
  TextEditingController? txtCpfTextController;
  final txtCpfMask = MaskTextInputFormatter(mask: '###.###.###-##');
  String? Function(BuildContext, String?)? txtCpfTextControllerValidator;
  // State field(s) for txtGrauParentesco widget.
  FocusNode? txtGrauParentescoFocusNode;
  TextEditingController? txtGrauParentescoTextController;
  String? Function(BuildContext, String?)?
      txtGrauParentescoTextControllerValidator;
  // State field(s) for txtDataNascimento widget.
  FocusNode? txtDataNascimentoFocusNode;
  TextEditingController? txtDataNascimentoTextController;
  final txtDataNascimentoMask = MaskTextInputFormatter(mask: '##/##/####');
  String? Function(BuildContext, String?)?
      txtDataNascimentoTextControllerValidator;
  // Stores action output result for [Custom Action - documentPicker] action in Button widget.
  List<FFUploadedFile>? fileData;
  // State field(s) for Checkbox widget.
  bool? checkboxValue;
  // Stores action output result for [Backend Call - API (SolicitacaoIncluirDependente)] action in ButtonConfirmar widget.
  ApiCallResponse? apiResultAlteraDependente;

  @override
  void initState(BuildContext context) {}

  @override
  void dispose() {
    txtNomeCompletoFocusNode?.dispose();
    txtNomeCompletoTextController?.dispose();

    txtCpfFocusNode?.dispose();
    txtCpfTextController?.dispose();

    txtGrauParentescoFocusNode?.dispose();
    txtGrauParentescoTextController?.dispose();

    txtDataNascimentoFocusNode?.dispose();
    txtDataNascimentoTextController?.dispose();
  }
}
