import '/backend/api_requests/api_calls.dart';
import '/flutter_flow/flutter_flow_animations.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:async';
import 'dart:math';
import 'dart:ui';
import '/backend/schema/structs/index.dart';
import '/flutter_flow/custom_functions.dart' as functions;
import 'login_widget.dart' show LoginWidget;
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:flutter/services.dart';
import 'package:flutter_animate/flutter_animate.dart';
import 'package:flutter_keyboard_visibility/flutter_keyboard_visibility.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:local_auth/local_auth.dart';
import 'package:mask_text_input_formatter/mask_text_input_formatter.dart';
import 'package:provider/provider.dart';

class LoginModel extends FlutterFlowModel<LoginWidget> {
  ///  State fields for stateful widgets in this page.

  bool biometricVerificartion = false;
  // Stores action output result for [Backend Call - API (UserLogin)] action in Login widget.
  ApiCallResponse? apiResultlh2B;
  // Stores action output result for [Backend Call - API (getTokenAvantino)] action in Login widget.
  ApiCallResponse? loginAvantinoResultB;
  // Stores action output result for [Backend Call - API (getRepresentantes)] action in Login widget.
  ApiCallResponse? representantesB;
  // State field(s) for txtCpf widget.
  FocusNode? txtCpfFocusNode;
  TextEditingController? txtCpfTextController;
  final txtCpfMask = MaskTextInputFormatter(mask: '###.###.###-##');
  String? Function(BuildContext, String?)? txtCpfTextControllerValidator;
  // State field(s) for txtSenha widget.
  FocusNode? txtSenhaFocusNode;
  TextEditingController? txtSenhaTextController;
  late bool txtSenhaVisibility;
  String? Function(BuildContext, String?)? txtSenhaTextControllerValidator;
  // State field(s) for SwitchBiometria widget.
  bool? switchBiometriaValue;
  // Stores action output result for [Backend Call - API (UserLogin)] action in Button widget.
  ApiCallResponse? apiResultlh2;
  // Stores action output result for [Backend Call - API (getTokenAvantino)] action in Button widget.
  ApiCallResponse? loginAvantinoResult;
  // Stores action output result for [Backend Call - API (getRepresentantes)] action in Button widget.
  ApiCallResponse? representantes;

  @override
  void initState(BuildContext context) {
    txtSenhaVisibility = false;
  }

  @override
  void dispose() {
    txtCpfFocusNode?.dispose();
    txtCpfTextController?.dispose();

    txtSenhaFocusNode?.dispose();
    txtSenhaTextController?.dispose();
  }
}
