import '/backend/schema/structs/index.dart';
import '/components/plano_card_widget.dart';
import '/flutter_flow/flutter_flow_theme.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/flutter_flow/flutter_flow_widgets.dart';
import 'dart:ui';
import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:provider/provider.dart';
import 'meus_planos_model.dart';
export 'meus_planos_model.dart';

class MeusPlanosWidget extends StatefulWidget {
  const MeusPlanosWidget({
    super.key,
    this.contratos,
  });

  final List<ContratoStruct>? contratos;

  @override
  State<MeusPlanosWidget> createState() => _MeusPlanosWidgetState();
}

class _MeusPlanosWidgetState extends State<MeusPlanosWidget> {
  late MeusPlanosModel _model;

  final scaffoldKey = GlobalKey<ScaffoldState>();

  @override
  void initState() {
    super.initState();
    _model = createModel(context, () => MeusPlanosModel());

    WidgetsBinding.instance.addPostFrameCallback((_) => safeSetState(() {}));
  }

  @override
  void dispose() {
    _model.dispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Title(
        title: 'MeusPlanos',
        color: FlutterFlowTheme.of(context).primary.withAlpha(0XFF),
        child: GestureDetector(
          onTap: () {
            FocusScope.of(context).unfocus();
            FocusManager.instance.primaryFocus?.unfocus();
          },
          child: Scaffold(
            key: scaffoldKey,
            backgroundColor: Color(0xFFF7F5F6),
            body: SafeArea(
              top: true,
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: [
                  Padding(
                    padding:
                        EdgeInsetsDirectional.fromSTEB(0.0, 0.0, 0.0, 20.0),
                    child: Row(
                      mainAxisSize: MainAxisSize.max,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        Text(
                          'Meus Planos',
                          style:
                              FlutterFlowTheme.of(context).bodyMedium.override(
                                    fontFamily: 'Inter',
                                    fontSize: 24.0,
                                    letterSpacing: 0.0,
                                    fontWeight: FontWeight.w800,
                                  ),
                        ),
                      ],
                    ),
                  ),
                  Expanded(
                    child: Container(
                      height: 600.0,
                      decoration: BoxDecoration(
                        color: FlutterFlowTheme.of(context).secondaryBackground,
                      ),
                      child: Builder(
                        builder: (context) {
                          final contratolista =
                              widget!.contratos?.toList() ?? [];

                          return ListView.builder(
                            padding: EdgeInsets.zero,
                            primary: false,
                            shrinkWrap: true,
                            scrollDirection: Axis.vertical,
                            itemCount: contratolista.length,
                            itemBuilder: (context, contratolistaIndex) {
                              final contratolistaItem =
                                  contratolista[contratolistaIndex];
                              return wrapWithModel(
                                model: _model.planoCardModels.getModel(
                                  contratolistaIndex.toString(),
                                  contratolistaIndex,
                                ),
                                updateCallback: () => safeSetState(() {}),
                                child: PlanoCardWidget(
                                  key: Key(
                                    'Keyujp_${contratolistaIndex.toString()}',
                                  ),
                                  nome: contratolistaItem.nmCobertura,
                                ),
                              );
                            },
                          );
                        },
                      ),
                    ),
                  ),
                ],
              ),
            ),
          ),
        ));
  }
}
